; ************************************************
; Datov struktura pole:
; 111XXXXX 0011YYYY	XXXXX: sloupec 0..23
;			 YYYY: dek 0..15
; formt bunk:
; MOSSPPPP	   M: 0/1 = fyzicky ptomn mina
;                  O: 0/1 = ji odhalen buka
;		  SS: 0-3 = vizuln stav buky
;                           (00: nestisknuto
;                            01: vlajka
;                            10: otaznk
;                            11: stisknuto)
;               PPPP: 0-8 = poet min v okol buky nebo
;                           po konci hry typ miny
;                           (9: mina
;                           10: krtnut mina
;                           11: smrtc mina)
;
; peddefinovan obtnosti:
; 0: pole 9x9   - 10min
; 1: pole 15x15 - 34min
; 2: pole 21x16 - 60min
;
; pozn. Nastaven hrac pole se me vyskytovat
;       kdekoliv ve vylenn datov struktue
;       a nemus bt zarovnno k okrajm.
; ************************************************

; *********************************************
; Zobraz minovho pole dle nastaven velikosti
; *********************************************

ZobrazPole
	lhld F_Left	; C = poet bunk na dku
	mov a,h
	sub l
	mov c,a
	mov d,l		; D = index MSB buky v LH rohu

	lhld F_Up	; B = poet bunk ve sloupci
	mov a,h
	sub l
	mov b,a
	mov e,l		; E = index LSB buky v LH rohu

	lxi h,Pole	; HL = ukazatel na buku
	dad d		;      v LH rohu pouit sti pole

ZobrazPoleX
	push b		; FOR X:= Xmin to Xmax
	push h
ZobrazPoleY
	mov a,m		; FOR Y:= Ymin to Ymax
	call ZobrazBunku ; zobraz bitmapu buky
	inr l		; index pole Y++
	dcr b		; odpoet vky pole
	jnz ZobrazPoleY	; NEXT Y
	pop h		; obnovit ukazatel pole
	pop b		; obnovit rozmry pole 
	inr h		; index pole X++
	dcr c		; odpoet ky pole
	jnz ZobrazPoleX	; NEXT X
	ret

; *****************************************************
; Na konci hry vykresl skutenou podobu minovho pole.
; Zvrazn nesouhlas mezi vlajkami a minami.
; *****************************************************

KontrolaPole
	lhld F_Left	; C = poet bunk na dku
	mov a,h
	sub l
	mov c,a
	mov d,l		; D = index MSB buky v LH rohu

	lhld F_Up	; B = poet bunk ve sloupci
	mov a,h
	sub l
	mov b,a
	mov e,l		; E = index LSB buky v LH rohu

	lxi h,Pole	; HL = ukazatel na buku
	dad d		;      v LH rohu pouit sti pole

KontrolaPoleX
	push b		; FOR X:= Xmin to Xmax
	push h
KontrolaPoleY
	mov a,m		; FOR Y:= Ymin to Ymax
	add a		; je v buce skuten mina?
	jc KontrolaPoleMina ; => kontrola vlajky
	mov a,m		; test oznaen vlajkou
	ani 70h		; ponechat oznaen buky
	cpi 10h		; je to vlajka?
	jz KontrolaPoleVlajka ; => kontrola skuten miny
	add a		; test na odhalen buky
	jm KontrolaPoleZustava ; ji odhalen buky neem
	mov a,m		; jinak je odhalm
	ori 40h		; (nastavenm atributu)
KontrolaPoleKorekce
	mov m,a		; zpis stavu buky po ppadn korekci
KontrolaPoleZustava
	inr l		; index pole Y++
	dcr b		; odpoet vky pole
	jnz KontrolaPoleY ; NEXT Y
	pop h		; obnovit ukazatel pole
	pop b		; obnovit rozmry pole 
	inr h		; index pole X++
	dcr c		; odpoet ky pole
	jnz KontrolaPoleX ; NEXT X
	ret

KontrolaPoleMina
	mov a,m			; je v buce (..s minou)
	ani 30h
	cpi 10h			; vlajka?
	jz KontrolaPoleZustava	; ANO => pak jdi na dal pole
	mvi a,01001001b		; NE => vyzna korekci
	jmp KontrolaPoleKorekce

KontrolaPoleVlajka
	mvi a,01001010b		; mina pod vlajkou nen (to je
				; vyloueno pedchozm testem)
	jmp KontrolaPoleKorekce	; proto udlm korekci
				; a vlom krtnutou minu

; **********************************************************
; Zobraz buku
; vstup: ACC = kd buky
;         HL = adresa buky v datov struktue minovho pole
; **********************************************************

ZobrazBunku
	push b		; uschovat registry do zsobnku
	push d
	push h
	xchg

	lxi h,0		; uschovat SP
	dad sp
	shld ZobrazBunkuSP+1

	add a		; test na odkrytou buku
	jm ZobrazBunkuOdkrytou
			; ODKRYT => pmo zobraz potisk
	rar		; NEODKRYT => pepotej slo
	rar		;              obrzku na buce
	rar		;              a pak pekresli buku
	rar
	ani 6
	adi 24
ZobrazBunkuOdkrytou
	ani 1eh		; maska pro adresu s potiskem buky
ZobrazBunkuStd
	lxi h,0		; adresa sady textur bunk
	mov c,a
	mvi b,0
	dad b		; pipost poad obrzku s potiskem
	mov a,m		; nast LSB adresy obrzku 
	inx h
	mov h,m		; nast MSB adresy obrzku
	mov l,a		; zkompletovat adresu obrzku
	sphl		; SP = adresa potisku pro buku

	xchg		; HL = adresa v minovm poli
	mov a,h		; nast slo sloupce
	ani 1fh		; ponechat jen funkn rozsah
	add a		; x2 (buky jsou irok 2 bajty)
	mov e,a
	mvi d,0		; DE = st adresy videoram od X
	mov a,l		; nast slo dku
	ani 0fh		; ponechat jen funkn rozsah
	add a		; x2 (pm index do tabulky int16)
	mov c,a
	mvi b,0		; BC = ofset v tabulce nsobk 14-ti
	lxi h,tbVysekRadku ; buky maj nekulatou vku 14pix
	dad b		; proto se nsoben x14 e tabulkou
	mov a,m		; nast vkovou adresu buky
	inx h		; ve videoram
	mov h,m
	mov l,a
	dad d		; pist kov pspvek adresy
			; HL = komplet adresa buky ve videoram
	lxi d,63	; DE = dkova
	mvi a,2		; poet opakovn (7x2=14 mikrodk)

ZobrazBunkuLoop
	pop b		; zkoprovat mikrodek 0 nebo 7
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 1 nebo 8
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 2 nebo 9
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 3 nebo 10
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 4 nebo 11
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 5 nebo 12
	mov m,c
	inx h
	mov m,b
	dad d
	pop b		; zkoprovat mikrodek 6 nebo 13
	mov m,c
	inx h
	mov m,b
	dad d
	dcr a		; postupn dv sedmice mikrodk
	jnz ZobrazBunkuLoop
	
ZobrazBunkuSP
	lxi sp,0	; obnovit zsobnk
	pop h		; a registry procesoru
	pop d
	pop b	
	ret
			; tabulka nsobk 14pixel na vku
tbVysekRadku
	.dw PlayArea+(0*14*64)
	.dw PlayArea+(1*14*64)
	.dw PlayArea+(2*14*64)
	.dw PlayArea+(3*14*64)
	.dw PlayArea+(4*14*64)
	.dw PlayArea+(5*14*64)
	.dw PlayArea+(6*14*64)
	.dw PlayArea+(7*14*64)
	.dw PlayArea+(8*14*64)
	.dw PlayArea+(9*14*64)
	.dw PlayArea+(10*14*64)
	.dw PlayArea+(11*14*64)
	.dw PlayArea+(12*14*64)
	.dw PlayArea+(13*14*64)
	.dw PlayArea+(14*14*64)
	.dw PlayArea+(15*14*64)

; ***********************************************
; Narazil jsem na jet neodhalenou buku
; a tak zanu podle pravidel odkrvat minov pole
; ***********************************************

OdkryjMinovePole
	lxi b,0		; zarku 0000h (konec seznamu)
	push b		; ulom do zsobnku 

	xchg		; B,C = rozsah bunk na dku
	lhld F_Left	; D,E = rozsah bunk ve sloupci 
	mov b,h
	mov c,l
	lhld F_Up
	xchg
	inr c		; korekce limit pole pro testy soused
	dcr b		; posunu dovnit minovho pole
	inr e		; (krajn buky nemaj vnj sousedy)
	dcr d
			; zatek smyky odkrvn
OdkryjPole
	in uartcwr	; hldm plynut asu
	ani 4
	cnz SafeZmenaCasu

	mov a,m		; peti stav buky
	ana a		; a otestuj
	jnz OdkryjPoleZobrazBunku

			; jsem na neodhalen neoznaen buce

	mov a,h		; pi testu L okol kontrola
	ani 1fh		; pozice buky
	cmp c		; zda nejsem v poli pln vlevo
	jc OdkryjPoleL	; pokud ano, netestuji vlevo
	dcr h		; jinak se posunu doleva
	push h		; zapamatuji si adresu buky [-1,0]
	inr h		; a vrtm se na pvodn pozici
OdkryjPoleL

	cmp b		; nejsem v poli pln vpravo?
	jnc OdkryjPoleR	; pokud ano, netestuji vpravo
	inr h		; jinak se posunu doprava
	push h		; zapamatuji si adresu buky [+1,0]
	dcr h		; a vrtm se na pvodn pozici
OdkryjPoleR

	mov a,l		; nyn vkov test
	ani 0fh		; z adresy vypreparuji index Y
	cmp e		; porovnm s minimln hodnotou (horn)
	jc OdkryjPoleU	; na hornm okraji bez hornch soused 
	dcr l		; u ostatnch bunk se posunu nahoru
	push h		; uschovm pozici buky [0,-1]
	mov a,h		; nyn jet test diagonln buky LH
	ani 1fh		; ponechm jen index X
	cmp c		; porovnm s minimln hodnotou (levou)
	jc OdkryjPoleUL	; na levm okraji bez soused vlevo
	dcr h		; jinak se ovem posunu doleva
	push h		; zapamatuji si adresu buky [-1,-1]
	inr h		; a vrtm se na pvodn pozici
OdkryjPoleUL
	cmp b		; porovnm s max hodnotou (pravou+1)
	jnc OdkryjPoleUR ; na pravm okraji bez soused vpravo
	inr h		; jinak se ovem posunu doprva
	push h		; zapamatuji si adresu buky [+1,-1]
	dcr h		; a vrtm se na pvodn pozici
OdkryjPoleUR
	inr l		; vrtm se na pvodn pozici [0,0]
OdkryjPoleU

	mov a,l		; tot v bledmodrm pro test dol..
	ani 0fh
	cmp d
	jnc OdkryjPoleD
	inr l
	push h
	mov a,h
	ani 1fh
	cmp c
	jc OdkryjPoleDL
	dcr h
	push h
	inr h
OdkryjPoleDL
	cmp b
	jnc OdkryjPoleDR
	inr h
	push h
	dcr h
OdkryjPoleDR
	dcr l
OdkryjPoleD

OdkryjPoleZobrazBunku		; HL ukazuje na aktuln buku
	mov a,m			; petu jej hodnotu
	ani 70h			; a pokud je u odhalen,
	jnz OdkryjPoleDalsi	; zahodm ji a jdu na dal..

	mov a,m			; neodhalen buce
	ori 40h			; zmnm status na "odhalen"
	mov m,a			; stav buky ulom
	call ZobrazBunku	; buku pekreslm na obrazovce

	lhld VolnychBunek	; snm poet jet
	dcx h			; neodhalench bunk
	shld VolnychBunek

OdkryjPoleDalsi
	pop h			; vyndm ze zsobnku adresu
	mov a,h			; dal buky, otestuji
	ora l			; na nulovou hodnotu
	jnz OdkryjPole		; je-li nenulov, tedy platn,
				; odkryji ji a pokrauji z n

	ret			; nalezen zarka 0000h => end

; *******************************************************
; Analza okol vybran buky
; sete okoln vlajky a vygeneruje seznam przdnch bunk
; *******************************************************

OtestujOkoli
	xra a			; vynulovat
	sta PocetMin		; poet fyzickch min kolem
	sta PocetSousedu	; a poet neodhalench soused

	push h			; vpoet doraz
	lhld F_Left		; HORIZ = (E+1)..(D)
	xchg
	lhld F_Up		; VERT = (C+1)..(B)
	mov b,h			; (indexy jsou sprvn!!!)
	mov c,l
	pop h
	inr e
	dcr d
	inr c
	dcr b
				; test trojice nad bukou
	mov a,l			; z adresy buky
	ani 0fh			; vypreparuji index Y
	cmp c			; test na horn okraj pole
	jc NescitejHorni	; nahoe nemm sousedy.. 
	dcr l			; jinak se ovem posunu nahoru
	call SectiRadek		; analyzuji tam buky (3x) 
	inr l			; a vrtm se na pvodn pozici
NescitejHorni

	call SectiRadek		; analza bunk (3x) v rovni 0

				; test trojice pod bukou
	mov a,l			; z adresy buky
	ani 0fh			; vypreparuji index Y
	cmp b			; test na spodn okraj pole
	jnc NescitejDolni	; dole namm sousedy..
	inr l			; jinak se ovem posunu dol
	call SectiRadek		; analyzuji tam buky (3x) 
	dcr l			; a vrtm se na pvodn pozici
NescitejDolni
	ret	
				; analza t bunk na dku
SectiRadek			; nejprve analza lev buky
	mov a,h			; z adresy buky
	ani 1fh			; vypreparuji index X
	cmp e			; test na lev okraj pole
	jc NescitejLevy		; vlevo nemm sousedy..
	dcr h			; jinak se ovem posunu doleva
	call AnalyzujBunku	; analyzuji tam buku (jedinou)
	inr h			; a vrtm se na pvodn pozici
NescitejLevy
	call AnalyzujBunku	; analza stedn buky trojice
	mov a,h			; a nyn analza prav buky
	ani 1fh			; vypreparuji index X
	cmp d			; test na prav okraj pole
	rnc			; vpravo nemm sousedy => konec
	inr h			; jinak se posunu doprava
	call AnalyzujBunku	; analyzuji tam buku (jedinou)
	dcr h			; a vrtm se na pvodn pozici
	ret

AnalyzujBunku
	mov a,m			; natu hodnotu buky
	ani 70h			; nechm jen atribut "odhalen"
				; a ppadn stav vlajka/?
	cz NeodkrytaBunka	; buka je neodhalen => zapi
	mov a,m			; jet test na poet vlajek
	ani 70h			; nechm jen atribut "odhalen"
				; a ppadn stav vlajka/?
	cpi 10h			; test na stav "vlajka"
	rnz			; nen vlajka => konec
	lda PocetMin		; s kadou vlajkou v okol
	inr a			; analyzovan buky zvednu
	sta PocetMin		; poet pedpokldanch min
	ret

NeodkrytaBunka
	push d			; uschovat registry
	push h
	lda PocetSousedu	; do seznamu neodhalench
	add a			; soused
	lxi h,SeznamSousedu
	rst 2
	pop d
	mov m,e			; pidm adresu analyzovan
	inx h			; buky
	mov m,d
	xchg
	pop d
	lda PocetSousedu	; a zvednu poet neodhalench
	inr a			; bunk v sousedstv
	sta PocetSousedu
	ret
