CellM	.equ 80h	; kd buky s minou
CellE	.equ 00h	; kd buky bez miny

; *******************************************
; Vygeneruje minov pole dle zadan velikosti
; *******************************************

InitPole

; ************************************************
; Nejprve cel pole vypln minami, kter slou
; jako sten mantinel pro pozdj rozmisovn
; ************************************************

InitPoleFill
	lxi b,(32*256)+16	; B=32, C=16
	lxi h,Pole		; adresa minovho pole
InitPoleFillX
	push b			; uschovat tae rozmru pole
	push h			; uschovat pozici
				; nahoe ve sloupci
InitPoleFillY
	mvi m,CellM		; zaminovat buku
	inr l			; indexY++
	dcr c			; odpoet svislch bunk
	jnz InitPoleFillY
	pop h			; obnovit adresu
				; nahoe ve sloupci
	pop b			; obnovit tae rozmru pole
	inr h			; indexX++
	dcr b			; odpoet vodorovnch bunk
	jnz InitPoleFillX
	
; *************************************
; Pak pracovn st pole vyist od min
; *************************************

	lhld F_Left	; C = poet bunk na dku
	mov a,h
	sub l
	mov c,a
	mov d,l		; D = index MSB buky v LH rohu

	lhld F_Up	; B = poet bunk ve sloupci
	push h
	mov a,h
	sub l
	mov b,a
	mov e,l		; E = index LSB buky v LH rohu

	lxi h,Pole	; HL = ukazatel na buku v LH rohu
	dad d

	push b		; uschovat parametry pole
	push h		; pro stn soused

InitPoleX
	push b		; uschovat rozmry pole
	push h		; a aktuln adresu pole
InitPoleY
	mvi m,CellE	; aktuln buka nem minu
	inx h		; indexY++
	dcr b		; odpoet vky pole
	jnz InitPoleY
	pop h		; obnovit adresu na zatku sloupce
	pop b		; obnovit rozmry pole
	inr h		; indexX++
	dcr c		; odpoet ky pole
	jnz InitPoleX

; ***********************************
; Nyn se kon vlastn rozmstn min
; ***********************************

	#ifdef FIX_PATTERN
	call FixPattern	; fixn vzor pro ely ladn
	#else
	call RandomPattern
	#endif

	#ifdef KONTROLUJ_MINY
	; pro jistotu spotm rozmstn miny
	pop h		; adresa buky v LH rohu
	pop b		; B = Ysize, C = Xsize
	push b
	push h
	mvi d,0
SectiPolozeneMinyX
	push b		; uschovat poitadla dk a sloupc
	push h		; uschovat adresu buky
SectiPolozeneMinyY
	mov a,m		; nast buku
	ana a		; je v n fyzicky mina?
	jp NeniZdeMina
	inr d
NeniZdeMina
	inx h		; Y++
	dcr b		; odpoet vky minovho pole
	jnz SectiPolozeneMinyY
	pop h		; obnovit adresu na zatku sloupce
	pop b		; obnovit poitadla dk/sloupc
	inr h		; X++
	dcr c		; odpoet ky minovho pole
	jnz SectiPolozeneMinyX
	lda ZbytekMin
	cmp d
	jnz $
	#endif

; *****************************************
; Nsledn se do bunk dopln poty soused
; abych se s tm pi odkrvn nezdroval
; *****************************************

	pop h		; adresa buky v LH rohu
	pop b		; B = Ysize, C = Xsize
	pop d		; D = Fdown+1, E = Fup
	dcr d
	inr e

SectiSousedyX
	push b		; uschovat poitadla dk a sloupc
	push h		; uschovat adresu buky
SectiSousedyY
	mov a,m		; nast buku
	ana a		; je v n fyzicky mina?
	cm SectiSousedyMina ; => piti +1 u vech soused
	inx h		; Y++
	dcr b		; odpoet vky minovho pole
	jnz SectiSousedyY
	pop h		; obnovit adresu na zatku sloupce
	pop b		; obnovit poitadla dk/sloupc
	inr h		; X++
	dcr c		; odpoet ky minovho pole
	jnz SectiSousedyX

	ret

; ************************************************************
; Pi stn soused jsem nael minu, proto pitu jedniku
; k okolnm bukm. Je to rychlej ne pro kadou buku
; stat okoln miny.
; Svisl index hldm na peteen krajnch hodnot, protoe
; se vyuv pln rozsah pole 0..15. Vodorovn index
; nehldm, protoe se pln rozsah pole nevyuv a klidn
; mohu pitat miny v bukch mimo aktivn st hracho pole.
; V tomto ppad neopustm alokovanou pam pro pole.
; ************************************************************

SectiSousedyMina
	mov a,l
	ani 0fh
	cmp d		; CY=0 pro Y>Ymax
	inr h		; => [+1,0]
	inr m		; na pozici [+1,0] pidej minu
	inr l		; => [+1,+1]
	jnc $+4		; v dolnm dku pesko pozici [+1,+1]
	inr m		; na pozici [+1,1] pidej minu
	dcr h		; => [0,+1]
	jnc $+4		; v dolnm dku pesko pozici [0,+1]
	inr m		; na pozici [0,1] pidej minu
	dcr h		; => [-1,+1]
	jnc $+4		; v dolnm dku pesko pozici [-1,+1]
	inr m		; na pozici [-1,1] pidej minu
	dcr l		; => [-1,0]
	inr m		; na pozici [-1,0] pidej minu
	cmp e		; CY=1 pro Y<Ymin
	dcr l		; => [-1,-1]
	jc $+4		; v hornm dku pesko pozici [-1,-1]
	inr m		; na pozici [-1,-1] pidej minu
	inr h		; => [0,-1]
	jc $+4		; v hornm dku pesko pozici [0,-1]
	inr m		; na pozici [0,-1] pidej minu
	inr h		; => [+1,-1]
	jc $+4		; v hornm dku pesko pozici [+1,-1]
	inr m		; na pozici [+1,-1] pidej minu
	inr l		; =>nvrat na [+0,+0]
	dcr h
	ret

; ***********************************************************
; Fixn rozmstn min pro ely ladn - podmnn kompilace
; ***********************************************************

	#ifdef FIX_PATTERN

FixPattern
	lxi h,Pole+6+(256*9)
	mvi m,CellM
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	dcr h
	dcr h
	inr l
	mvi m,CellM
	dcr h
	dcr h
	mvi m,CellM
	inr l
	mvi m,CellM
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	dcr h
	inr l
	mvi m,CellM
	dcr h
	dcr h
	mvi m,CellM
	inr l	
	mvi m,CellM
	inr h
	inr h
	mvi m,CellM
	inr h
	mvi m,CellM
	ret

	#endif

; **********************************
; Homogenn rozmstn min s variac
; **********************************

RandomPattern
	lda PoleSize	; dle velikosti minovho pole
	lxi h,tbSeeds	; a tabulky homogennch layout min 
	rst 3		; vybere tu pravou tabulku
	mov c,m		; C = poet min v poli
	inx h		; pesun na vlastn seznam min
	mvi b,CellM	; B = kd poloen miny

RandomPatternLoop

RandomPatternY
	mov e,m		; LSB PTR do minovho pole
	call GetSignedRandom
	add e		; k pozici Y pitu -3..+3
	mov e,a
	ani 30h
	cpi 30h		; a pi oputn minovho pole
	jnz RandomPatternY ; zkusm znovu

RandomPatternX
	inx h
	mov d,m		; MSB PTR do minovho pole
	dcx h
	call GetSignedRandom
	add d		; k pozici X pitu -3..+3
	mov d,a
	ani 0e0h
	cpi 0e0h	; a pi oputn minovho pole
	jnz RandomPatternX ; zkusm znovu

	ldax d		; je na clov adrese v minovm poli
	cpi CellM	; u mina?
	jz RandomPatternLoop ; zkus novou pozici

	mov a,b		; kd miny
	stax d		; polo do minovho pole
	inx h		; posun v seznamu na dal minu
	inx h
	dcr c		; odpoet pokldanch min
	jnz RandomPatternLoop

	ret

; *********************
; Vrac (signed int)RND
; *********************

GetSignedRandom
	call MoreRandom	; zamchat genertorem podle asu v T2
	call GetRandom	; nate obecn nhodn slo
	ani 7		; ponech jen 3 spodn bity
	rar		; dva nech, jeden vsune do CY
	rnc		; CY=0? => vra 0..+3
	cma		; CY=1?
	inr a		; => vra -3..0
	ret

; *****************************************************
; Pro vechny ti velikosti minovho pole jsou obsaeny
; zcela homogenn vzory s rozmstnm min. Pozdji se
; dle nhody provedou jemn variace pozice.
; *****************************************************

tbSeeds
	.dw tbSeed0,tbSeed1,tbSeed2

#ifndef NARROW_PATTERN

tbSeed0
	.db POCET_MIN_L0	; new set
	.dw Pole+4+(256*7)	; *...*...*
	.dw Pole+4+(256*11)	; .........
	.dw Pole+4+(256*15)	; .........
	.dw Pole+7+(256*9)	; ..*...*..
	.dw Pole+7+(256*13)	; .........
	.dw Pole+9+(256*9)	; ..*...*..
	.dw Pole+9+(256*13)	; .........
	.dw Pole+12+(256*7)	; .........
	.dw Pole+12+(256*11)	; *.......*
	.dw Pole+12+(256*15)

tbSeed1
	.db POCET_MIN_L1
	.dw Pole+2+(256*6)	; ...............
	.dw Pole+2+(256*8)	; ...............
	.dw Pole+2+(256*10)	; ..*.*.*.*.*.*..
	.dw Pole+2+(256*12)	; ...............
	.dw Pole+2+(256*14)	; ..*.*.*.*.*.*..
	.dw Pole+2+(256*16)	; ...............
	.dw Pole+4+(256*6)	; ...*.*.*.*.*...
	.dw Pole+4+(256*8)	; ...............
	.dw Pole+4+(256*10)	; ...*.*.*.*.*...
	.dw Pole+4+(256*12)	; ...............
	.dw Pole+4+(256*14)	; ..*.*.*.*.*.*..
	.dw Pole+4+(256*16)	; ...............
	.dw Pole+6+(256*7)	; ..*.*.*.*.*.*..
	.dw Pole+6+(256*9)	; ...............
	.dw Pole+6+(256*11)	; ...............
	.dw Pole+6+(256*13)
	.dw Pole+6+(256*15)
	.dw Pole+8+(256*7)
	.dw Pole+8+(256*9)
	.dw Pole+8+(256*11)
	.dw Pole+8+(256*13)
	.dw Pole+8+(256*15)
	.dw Pole+10+(256*6)
	.dw Pole+10+(256*8)
	.dw Pole+10+(256*10)
	.dw Pole+10+(256*12)
	.dw Pole+10+(256*14)
	.dw Pole+10+(256*16)
	.dw Pole+12+(256*6)
	.dw Pole+12+(256*8)
	.dw Pole+12+(256*10)
	.dw Pole+12+(256*12)
	.dw Pole+12+(256*14)
	.dw Pole+12+(256*16)

tbSeed2
	.db POCET_MIN_L2
	.dw Pole+2+(256*3)	; .....................
	.dw Pole+1+(256*5)	; ....*...*...*...*....
	.dw Pole+2+(256*7)	; ..*...*...*...*...*..
	.dw Pole+1+(256*9)	; ....*...*...*...*....
	.dw Pole+2+(256*11)	; ..*...*...*...*...*..
	.dw Pole+1+(256*13)	; ....*...*...*...*....
	.dw Pole+2+(256*15)	; ..*...*.......*...*..
	.dw Pole+1+(256*17)	; ....*...*...*...*....
	.dw Pole+2+(256*19)	; ..*...*.......*...*..
	.dw Pole+4+(256*3)	; ....*...*...*...*....
	.dw Pole+3+(256*5)	; ..*...*.......*...*..
	.dw Pole+4+(256*7)	; ....*...*...*...*....
	.dw Pole+3+(256*9)	; ..*...*...*...*...*..
	.dw Pole+4+(256*11)	; ....*...*...*...*....
	.dw Pole+3+(256*13)	; ..*...*...*...*...*..
	.dw Pole+4+(256*15)	; .....................
	.dw Pole+3+(256*17)
	.dw Pole+4+(256*19)
	.dw Pole+6+(256*3)
	.dw Pole+5+(256*5)
	.dw Pole+6+(256*7)
	.dw Pole+5+(256*9)
	.dw Pole+5+(256*13)
	.dw Pole+6+(256*15)
	.dw Pole+5+(256*17)
	.dw Pole+6+(256*19)
	.dw Pole+8+(256*3)
	.dw Pole+7+(256*5)
	.dw Pole+8+(256*7)
	.dw Pole+7+(256*9)
	.dw Pole+7+(256*13)
	.dw Pole+8+(256*15)
	.dw Pole+7+(256*17)
	.dw Pole+8+(256*19)
	.dw Pole+10+(256*3)
	.dw Pole+9+(256*5)
	.dw Pole+10+(256*7)
	.dw Pole+9+(256*9)
	.dw Pole+9+(256*13)
	.dw Pole+10+(256*15)
	.dw Pole+9+(256*17)
	.dw Pole+10+(256*19)
	.dw Pole+12+(256*3)
	.dw Pole+11+(256*5)
	.dw Pole+12+(256*7)
	.dw Pole+11+(256*9)
	.dw Pole+12+(256*11)
	.dw Pole+11+(256*13)
	.dw Pole+12+(256*15)
	.dw Pole+11+(256*17)
	.dw Pole+12+(256*19)
	.dw Pole+14+(256*3)
	.dw Pole+13+(256*5)
	.dw Pole+14+(256*7)
	.dw Pole+13+(256*9)
	.dw Pole+14+(256*11)
	.dw Pole+13+(256*13)
	.dw Pole+14+(256*15)
	.dw Pole+13+(256*17)
	.dw Pole+14+(256*19)

#else

tbSeed0
	.db POCET_MIN_L0	; old set
	.dw Pole+6+(256*8)	; .........
	.dw Pole+5+(256*11)	; ....*....
	.dw Pole+6+(256*14)	; .*.....*.
	.dw Pole+8+(256*8)	; .........
	.dw Pole+8+(256*10)	; .*.*.*.*.
	.dw Pole+8+(256*12)	; .........
	.dw Pole+8+(256*14)	; .*.....*.
	.dw Pole+10+(256*8)	; ....*....
	.dw Pole+11+(256*11)	; .........
	.dw Pole+10+(256*14)

tbSeed1
	.db POCET_MIN_L1
	.dw Pole+2+(256*6)	; ...............
	.dw Pole+2+(256*8)	; ...............
	.dw Pole+2+(256*10)	; ..*.*.*.*.*.*..
	.dw Pole+2+(256*12)	; ...............
	.dw Pole+2+(256*14)	; ..*.*.*.*.*.*..
	.dw Pole+2+(256*16)	; ...............
	.dw Pole+4+(256*6)	; ...*.*.*.*.*...
	.dw Pole+4+(256*8)	; ...............
	.dw Pole+4+(256*10)	; ...*.*.*.*.*...
	.dw Pole+4+(256*12)	; ...............
	.dw Pole+4+(256*14)	; ..*.*.*.*.*.*..
	.dw Pole+4+(256*16)	; ...............
	.dw Pole+6+(256*7)	; ..*.*.*.*.*.*..
	.dw Pole+6+(256*9)	; ...............
	.dw Pole+6+(256*11)	; ...............
	.dw Pole+6+(256*13)
	.dw Pole+6+(256*15)
	.dw Pole+8+(256*7)
	.dw Pole+8+(256*9)
	.dw Pole+8+(256*11)
	.dw Pole+8+(256*13)
	.dw Pole+8+(256*15)
	.dw Pole+10+(256*6)
	.dw Pole+10+(256*8)
	.dw Pole+10+(256*10)
	.dw Pole+10+(256*12)
	.dw Pole+10+(256*14)
	.dw Pole+10+(256*16)
	.dw Pole+12+(256*6)
	.dw Pole+12+(256*8)
	.dw Pole+12+(256*10)
	.dw Pole+12+(256*12)
	.dw Pole+12+(256*14)
	.dw Pole+12+(256*16)

tbSeed2
	.db POCET_MIN_L2
	.dw Pole+2+(256*3)	; .....................
	.dw Pole+1+(256*5)	; ....*...*...*...*....
	.dw Pole+2+(256*7)	; ..*...*...*...*...*..
	.dw Pole+1+(256*9)	; ....*...*...*...*....
	.dw Pole+2+(256*11)	; ..*...*...*...*...*..
	.dw Pole+1+(256*13)	; ....*...*...*...*....
	.dw Pole+2+(256*15)	; ..*...*.......*...*..
	.dw Pole+1+(256*17)	; ....*...*...*...*....
	.dw Pole+2+(256*19)	; ..*...*.......*...*..
	.dw Pole+4+(256*3)	; ....*...*...*...*....
	.dw Pole+3+(256*5)	; ..*...*.......*...*..
	.dw Pole+4+(256*7)	; ....*...*...*...*....
	.dw Pole+3+(256*9)	; ..*...*...*...*...*..
	.dw Pole+4+(256*11)	; ....*...*...*...*....
	.dw Pole+3+(256*13)	; ..*...*...*...*...*..
	.dw Pole+4+(256*15)	; .....................
	.dw Pole+3+(256*17)
	.dw Pole+4+(256*19)
	.dw Pole+6+(256*3)
	.dw Pole+5+(256*5)
	.dw Pole+6+(256*7)
	.dw Pole+5+(256*9)
	.dw Pole+5+(256*13)
	.dw Pole+6+(256*15)
	.dw Pole+5+(256*17)
	.dw Pole+6+(256*19)
	.dw Pole+8+(256*3)
	.dw Pole+7+(256*5)
	.dw Pole+8+(256*7)
	.dw Pole+7+(256*9)
	.dw Pole+7+(256*13)
	.dw Pole+8+(256*15)
	.dw Pole+7+(256*17)
	.dw Pole+8+(256*19)
	.dw Pole+10+(256*3)
	.dw Pole+9+(256*5)
	.dw Pole+10+(256*7)
	.dw Pole+9+(256*9)
	.dw Pole+9+(256*13)
	.dw Pole+10+(256*15)
	.dw Pole+9+(256*17)
	.dw Pole+10+(256*19)
	.dw Pole+12+(256*3)
	.dw Pole+11+(256*5)
	.dw Pole+12+(256*7)
	.dw Pole+11+(256*9)
	.dw Pole+12+(256*11)
	.dw Pole+11+(256*13)
	.dw Pole+12+(256*15)
	.dw Pole+11+(256*17)
	.dw Pole+12+(256*19)
	.dw Pole+14+(256*3)
	.dw Pole+13+(256*5)
	.dw Pole+14+(256*7)
	.dw Pole+13+(256*9)
	.dw Pole+14+(256*11)
	.dw Pole+13+(256*13)
	.dw Pole+14+(256*15)
	.dw Pole+13+(256*17)
	.dw Pole+14+(256*19)

#endif
