; *********************************************************
; Zkopruje zlon obrazovku od 4000h do fyzick obrazovky
; od C000h. Kvli rychlosti je volena metoda penosu dat
; za pomoci registru ukazatele zsobnku SP.
; *********************************************************

#define CopyVideo2 pop b\ mov m,c\ inx h\ mov m,b\ inx h

CopyVideoram
	lxi h,0		; uschovat hodnotu reg. SP
	dad sp
	shld CopyVideoramSP+1

	lxi sp,4000h	; odkud
	lxi h,0c000h	; kam
CopyVideoramLoop
	CopyVideo2	; zkoprovat 24 dvojic bajt
	CopyVideo2	; pomoc makra "CopyVideo2"
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	CopyVideo2
	lxi h,16	; peskoit "zpisnk" v zlon
	dad sp		; videoram od 4000h
	sphl
	lxi h,8000h	; a adekvtn peskoit i "zpisnk"
	dad sp		; ve fyzick vydeoram
	jnc CopyVideoramLoop ; do vyerpn videoram opakuj..

CopyVideoramSP
	lxi sp,0	; obnovit hodnotu reg. SP
	ret

; ****************************
; Kresl RAW bitmapov obrzek
; DE = pozice ve videoram
; HL = pedloha vetn rozmr
; ****************************

ShowImage
	mov c,m		; nast rozmr X obrzku
	inx h
	mov b,m		; nast rozmr Y obrzku
	inx h
	xchg		; DE = pedloha bitmapy
			; HL = adresa kreslen (ve videoram)
ShowImageY
	push b		; uschovat rozmry obrzku
	push h		; uschovat pozici videoram
ShowImageX
	lda ColAtr	; nast aktuln atribut barvy
	xchg
	ora m		; pidat data pedlohy obrzku
	xchg
	inx d		; dal bajt pedlohy
	mov m,a		; a zapsat do videoram
	inx h		; dal bajt videoram
	dcr c		; odpoet ky obrzku
	jnz ShowImageX	; NEXT X
	lhld ColAtr	; na konci kadho mikrodku
	mov a,h		; prohodm dvojici atribut Colorace
	mov h,l
	mov l,a
	shld ColAtr
	pop h		; obnovm adresu videoram (zatek
	lxi b,64	; mikrodku) a pitenm 64 se dostanu
	dad b		; na zatek dalho mikrodku
	pop b		; obnovm rozmry obrzku
	dcr b		; odetu dal mikrodek obrzku 
	jnz ShowImageY	; NEXT Y
	ret

; ***************************************************
; Vykreslen obrzku s implicitn maskou pozad
; (jedn se o pseudomasku jako alternativu k pixelm)
; BC = adresa pedlohy
; HL = clov adresa kreslen ve videoram (LH roh)
; ***************************************************

ShowMaskedImage
	ldax b		; nast ku obrzku
	inx b
	mov e,a
	ldax b		; nast vku obrzku
	inx b
	mov d,a
ShowMaskedImageSwap
	lda ColAtr	; sud Colorace atribut barvy
	sta ShowMaskedImageAtr+1 ; uloit do kreslic rutiny
	push d
	push h
ShowMaskedImageLine
	ldax b		; nast bajt pedlohy
	inx b		; dal bajt pedlohy
	ana a		; test atributu masky
	jm ShowMaskedImageMask ; => bajt s maskou
ShowMaskedImageAtr
	ori 0		; bajt bez masky doplnit barvou
	mov m,a		; a zapsat do videoram
ShowMaskedImageNext
	inx h		; dal bajt videoram (vpravo)
	dcr e		; odpoet ky obrzku
	jnz ShowMaskedImageLine ; NEXT X
	lhld ColAtr	; prohodit atributy barvy Colorace
	mov a,h		; na konci kadho mikrodku
	mov h,l
	mov l,a
	shld ColAtr
	pop h		; obnovit adresu videoram
	lxi d,64	; posun na zatek dalho mikrodku
	dad d
	pop d		; obnovit rozmry obrzku
	dcr d		; odpoet vky obrzku
	jnz ShowMaskedImageSwap ; NEXT Y
	ret

ShowMaskedImageMask
	ori 0c0h	; barvy nebudou maskou doteny
	ana m		; odmaskovat pozad maskou
	mov m,a		; zapsat do videoram
	jmp ShowMaskedImageNext ; dal bajt videoram

; **********************
; Inverze ikony oblieje
; **********************

InvertFace
	lhld AdresaObliceje
	lxi d,64	; posun zatku invertovan oblasti
	dad d		; vi jmenovitmu LH rohu ikony
	lxi d,61	; dkova
	mvi c,17	; vka invertovan oblasti
InvertFaceLoop
	mov a,m		; invertovat jeden mikrodek
	xri 38h
	mov m,a
	inx h
	mov a,m
	xri 3fh
	mov m,a
	inx h
	mov a,m
	xri 3fh
	mov m,a
	inx h
	mov a,m
	xri 1
	mov m,a
	dad d		; pechod na nov mikrodek
	dcr c		; odpoet vky ikony
	jnz InvertFaceLoop ; NEXT Y
	ret

; **************************************************
; Vmaz pomocn obrazovky od 4000h nastavenou barvou
; **************************************************

ClsTemp
	push h
	lxi h,0c030h-8000h
	shld ClsOdkud+1
	jmp ClsCommon

; *****************************************
; Vmaz fyzick obrazovky nastavenou barvou
; *****************************************

Cls	push h
	lxi h,0c030h	; vybrat zvolenou videoram
	shld ClsOdkud+1

ClsCommon
	xra a		; COLOR(0) uruje barvu pozad
	call SetCol
	lxi d,tbClsPattern
	mvi c,4		; 4 dvojice tvo cel vzor pozad
ClsSetPattern
	ldax d		; natu vzor pozad (sud bajt)
	ani 3fh		; odfiltruji star atribut
	ora l		; pidm nov sud atribut barvy
	stax d		; ulom zpt jako nov obarven vzor
	inx d
	ldax d		; natu vzor pozad (lich bajt)
	ani 3fh		; odfiltruji star atribut
	ora h		; pidm nov lich atribut barvy
	stax d		; ulom zpt jako nov obarven vzor
	inx d
	dcr c		; dal dvojice bajt pozad
	jnz ClsSetPattern

	lxi h,0
	dad sp		; uschovat hodnotu ukazatele
	shld ClsEnd+1	; vrcholku zsobnku

	lda ColorMode	; vybrat vzor pozad MONO/COLOR
	ana a
	lxi d,tbClsPattern ; vzorek pozad
	jnz ClsOdkud
	lxi d,tbClsPatNull ; przdn pozad
ClsOdkud
	lxi h,0c030h	; PH roh viditeln sti videoram

ClsNext
	ldax d		; nast dal bajt vzoru pozad
	inx d
	cpi -1		; a a dojdou, ukonit CLS
	jz ClsEnd
	mov b,a		; jinak vzor vloit do BC a vyplnit
	mov c,a		; s nimi 32 mikrodk videoram

	mvi a,32	; 32x8=256 pixel vky cel obrazovky
ClsLoop	sphl
	push b		; 24x 2 bajty = 48 bajt mikrodku
	push b		; ulom 48 bajt do fiktivnho
	push b		; zsobnku, kter si vdy zalom
	push b		; na konci kadho z 256-ti mikrodk
	push b		; videoram
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	push b
	inr h		; dal mikrodek bude o 8 ne
	inr h		; tj. +200h
	dcr a		; celkem 32x rozte po 8 mikrodcch
	jnz ClsLoop	; konec smyky kreslen jednoho bajtu
			; vzoru pozad
	lxi b,64-4000h	; pechod na kreslen dalho bajtu
	dad b		; vzoru pozad
	jmp ClsNext	; kresli dal z 8 bajt vzoru pozad

ClsEnd	lxi sp,0	; obnovit ukazatel vrcholku zsobnku
	pop h
	ret

tbClsPattern
	.db 1ch		; vzor pozad pro barevn reimy
	.db 24h
	.db 24h
	.db 23h
	.db 31h
	.db 09h
	.db 09h
	.db 0eh
	.db -1

tbClsPatNull
	.db 00h		; vzor pozad pro monochromatick reim
	.db 00h
	.db 00h
	.db 00h
	.db 00h
	.db 00h
	.db 00h
	.db 00h
	.db -1
