; ******************************
; Spoutc sekvence vlastn hry
; ******************************

NovaHra
	call NastavHru		; nastav promnn hry
	lhld AdresaObliceje	; zobraz std obliej
	xchg			; DE = adresa ve videoram
	lxi h,ImgTrueOblicej	; HL = pedloha ikony
	call ShowImage		; vlastn zobrazen ikony
	call InitPole		; generovn minovho pole
	call ZobrazPole		; vykresl hrac pole
	out uartdat		; restart asovae 0,5s
	call TiskCasuOutside	; a tisk asu bez kolize
				; s mym kurzorem
	call ZobrazPocetZbylychMin
				; tisk do zhlav
SmyckaHryMysOn
	rst 7			; aktivuje kurzor myi

; *************************************
; Hlavn smyka hry. Hr jezd s my,
; ek se na klik myi nebo stisk STOP
; *************************************

SmyckaHry
	call MoreRandom	; prbn mchm s genertorem nhod 

	lhld VolnychBunek
	mov a,h
	ora l		; po prokliknut vech volnch bunk
	jz Vyhra	; nsleduje vhra

	mvi a,1		; test klvesy K1 aka F2
	out kbdout
	in kbdin
	rar
	jnc PressF2	; vyvol restart hry
	ani 20h		; test klvesy STOP
	jz SpustMenu	; pi stisku skok do hlavnho menu

Ovladani
	call MysDriver	; jedn s my/klvesnic

	push psw	; stav tlatek uschovat (je nutno
	lda MysXCHG	; pout stav z procedury MysDriver,
	ana a		; protoe koresponduje s peruenm
	jz BezPohybu	; obsluhy myi)
	rst 6		; vypne kurzor myi
	rst 7		; a zapne jej na nov pozici
BezPohybu
	pop psw		; obnovit stav tlatek myi

	jm ClickLeft	; stisk L tlatka myi => obsluha
	jc ClickRight	; stisk P tlatka myi => obsluha

	in uartcwr	; uplynulo 0,5sec?
	ani 4
	cnz ZmenaCasu	; pokud ano, oetit asomru

	jmp SmyckaHry	; a jezdit ve smyce..

; ************************************
; Oeten stisku levho tlatka myi
; ************************************

ClickLeft
	call TestNaObliceji	; L klik na obliej?
	jc Click2Face		; ANO => restart hry

	lda GameOver		; pznak GameOver
	ana a			; otestuji
	jz ClickRelease		; hra skonila => odskok

	call DetekujBunku 	; do HL vybere adresu buky
	jc ClickRelease		; nebyl klik do minovho pole

	mov a,m			; kliknul jsem do minovho pole
	ani 70h			; test odhalenosti buky
	jnz ClickLeftGroup	; vlajky a otaznky

	lda MysSensitivity	; pi ovldn klvesnic ppne
	ana a
	cz Chirp

	call KlikNaBunku	; animuje kliknut + test
	jm Smrt			; je tam mina => smrt
				; nen tam mina =>
	call OdkryjMinovePole	; odhalm st minovho pole
	jmp SmyckaHryMysOn	; vracm se k ekn na klik 

; *******************************************
; Kliknut levm tlatkem na odhalenou buku
; *******************************************

ClickLeftGroup
	ani 40h			; je-li atribut odhalen
	jz ClickRelease		; neaktivn => konec

	call OtestujOkoli	; otestuje okol buky
	lda PocetMin		; je poet okolnch vlajek
	mov c,a
	mov a,m
	ani 0fh
	cmp c			; roven potu fyzickch min?
	jnz ClickRelease	; NE => ignoruj stisk

	lda PocetSousedu	; je vbec jet co v okol
	ana a			; odhalovat?
	jz ClickRelease		; NE => ignoruj stisk

	lda MysSensitivity	; pi ovldn klvesnic ppne
	ana a
	cz Chirp

	rst 6			; vypne kurzor myi
	lhld AdresaObliceje	; zobraz obliej ""
	lxi d,1+(10*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejOOO	; HL = pedloha ikony
	call ShowImage		; vlastn zobrazen ikony

	lda PocetSousedu	; podle potu neodhalench
	mov c,a			; soused
	lxi h,SeznamSousedu	; bere tyto ze seznamu
HromadnyKlik
	mov e,m			; a na jejich pozici
	inx h
	mov d,m
	inx h
	push h
	xchg
	mvi a,00110000b		; ikonu "prokliknut" buky
	call ZobrazBunku	; zobraz
	pop h
	dcr c			; dal soused ze seznamu
	jnz HromadnyKlik
	rst 7			; pak zapne kurzor myi
	call MouseKeyRelease	; pokat na uvolnn tlatka

	rst 6			; vypne kurzor myi
	lda PocetSousedu	; a pro vechny neodhalen
	mov c,a			; sousedy
	lxi h,SeznamSousedu	; ze seznamu
DalsiSoused
	mov e,m			; bere jejich pozice
	inx h
	mov d,m
	inx h
	ldax d			; a pokud jsem lpnul na minu,
	ana a
	jm SmrtDE		; vyvol smrt,
	push b
	push h
	xchg
	call OdkryjMinovePole	; jinak odhal minov pole
	pop h			; v okol tohoto souseda
	pop b
	dcr c			; dal soused ze seznamu
	jnz DalsiSoused
				; nic m nezabilo, a tak..
	lhld AdresaObliceje	; std ikona oblieje
	lxi d,1+(10*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejBack
	call ShowImage		; vlastn zobrazen ikony

	jmp SmyckaHryMysOn	; vracm se k ekn na klik 

; ***************************
; Stisk pravho tlatka myi
; ***************************

ClickRight
	lda GameOver		; pznak GameOver
	ana a			; otestuji
	jz ClickRelease		; hra skonila => odskok

	call DetekujBunku	; do HL vybere adresu buky
	jc ClickRelease		; nebyl click na buku

	mov a,m			; natu stav buky
	ani 70h			; jen "odhalen" + status
	mvi c,10h		; ikona vlajky
	lxi d,-1		; a snen potu zbv. min
	jz ZmenBunku		; nsleduje po przdn buce
	mvi c,00h		; ikona przdn buky
	inx d			; a beze zmny potu zbv. min
	cpi 20h			; nsleduje po otaznku
	jz ZmenBunku
	mvi c,20h		; ikona otaznku
	inx d			; a zven potu zbv. min
	cpi 10h			; nsleduje po vlajce
	jnz ClickRelease	; ostatn stavy bunk nereaguj
 
ZmenBunku
	lda MysSensitivity	; pi ovldn klvesnic ppne
	ana a
	cz Chirp

	push b			; uschovat kd poadovan ikony
	push h			; uschovat adresu buky
	lhld ZbytekMin		; korekce potu zbvajcch min
	dad d
	shld ZbytekMin
	call ZobrazPocetZbylychMin ; zobrazit poet zbv. min
	rst 6			; vypnout kurzor myi
	pop h			; obnovit adresu buky
	pop b			; obnovit kd poadovan ikony
	mov a,m			; nast star stav buky
	ani 8fh			; vymazat starou ikonu
	ora c			; vloit novou ikonu
	mov m,a			; zapsat zpt do minovho pole
	call ZobrazBunku	; buku vykreslit
	rst 7			; zapnout kurzor myi
ClickRelease
	call MouseKeyRelease	; ekat na uvolnn tla. myi
	jmp SmyckaHry		; zpt do reimu jedn s my

; *************************************************
; Z pozice kurzoru myi urm index v minovm poli,
; otestuji na rozsah souadnic pro dan level
; a vrtm ukazatel do minovho pole
; *************************************************

DetekujBunku
	lhld MysY
	inx h		; korekce zmrnho bodu dy = +1
	dad h 
	dad h 
	dad h 
	dad h 
	dad h 
	dad h
	mov a,h
	ori 0c0h
	mov h,a
	push h

	lhld MysX
	inx h		; korekce zmrnho bodu dx = +1
	mov a,h
	rar
	mov a,l
	rar
	mov l,a		; nejprve L := X/2
	mvi h,tbPix2Adr/256
	mov e,m		; DE := dkov adresa kurzoru myi
	mvi d,0
	pop h
	dad d
	
	lxi d,-PlayArea	; koriguji LH rohem pole ve videoram
	dad d

	mov a,l		; D = vodorovn index buky
	rar
	ani 1fh
	mov d,a

	dad h		; E = svisl index buky
	dad h
	mov a,h
	mvi e,-1
DetekujBunkuY
	inr e
	sui 14
	jnc DetekujBunkuY

	lhld F_Left	; test validity vodorovn pozice
	mov a,d
	cmp l
	rc
	cmp h
	cmc
	rc

	lhld F_Up	; test validity svisl pozice
	mov a,e
	cmp l
	rc
	cmp h
	cmc
	rc

	lxi h,Pole	; pepoet index na adresu pole
	dad d
	ret

; **************************************************
; Test pozice kurzoru myi, zda je na ikon oblieje
; vstup: CY=0 => nejsem na oblieji
; **************************************************

TestNaObliceji
	lhld PoziceObliceje
	xchg		; DE = lev horn roh ikony oblieje
	lxi h,1110h	; 16 pixel na ku, 17 na vku
	dad d		; BC = prav horn roh ikony +1/+1
	mov b,h
	mov c,l

	lhld MysX	; test pozice X
	inx h		; korekce zmrnho bodu
	mov a,h
	ana a
	rnz		; MSB<>0
	mov a,l
	cmp e
	cmc
	rnc		; kurzor pli vlevo
	cmp c
	rnc		; kurzor pli vpravo

	lhld MysY	; test pozice Y
	inx h		; korekce zmrnho bodu
	mov a,h
	ana a
	rnz		; MSB<>0
	mov a,l
	cmp d
	cmc
	rnc		; kurzor pli nahoe
	cmp b
	ret		; kurzor pli dole nebo OK

; *************************************************
; Prokliknut buky, ekn na release, ten stavu
; *************************************************

KlikNaBunku
	push h			; uschovat adresu buky
	rst 6			; vypne kurzor myi
	lhld AdresaObliceje	; zobraz obliej ""
	lxi d,1+(10*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejOOO	; HL = pedloha ikony
	call ShowImage		; vlastn zobrazen ikony
	pop h			; obnovit adresu buky
	mvi a,00110000b		; ikona "prokliknut" buky
	call ZobrazBunku	; zobrazit ji
	push h			; uschovat adresu buky
	rst 7			; zapnout kurzor myi
	call MouseKeyRelease	; pokat na uvolnn tlatka
	lhld AdresaObliceje	; zobraz obliej ""
	lxi d,1+(10*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejBack
	call ShowImage		; vlastn zobrazen ikony
	rst 6			; nyn vypnu kurzor myi, nebo
				; - bu kon hra nespchem
				; - budu dlouho odhalovat buky
	pop h			; obnovit adresu vybran buky

	mov a,m			; nast stav buky
	ana a			; test jej hodnoty
	ret

; *********************************************
; Kliknul jsem na ikonu oblieje => restart hry
; *********************************************

Click2Face
	call StopGame		; zastav hru (v. asu)
	rst 6			; vypni kurzor myi
	call InvertFace		; inverze oblieje
	rst 7			; zapni kurzor myi
	call MouseKeyRelease	; ekej na uvolnn L tlatka
	rst 6			; vypni kurzor myi
	jmp NovaHra		; restart hry

; ***************************
; Stisk K1/F2 pro restart hry
; ***************************

PressF2
	rst 6			; zhasne kurzor myi
	call StopGame		; zastav hru (v. asu)
	call KeyRelease		; pok na uvolnn klves
	jmp NovaHra		; restart hry

; *********************************************
; Smrt - lpnul jsem na minu
; prefix pro voln z hromadnho odhalen bunk
; *********************************************

SmrtDE
	xchg

; ***************************
; Smrt - lpnul jsem na minu
; ***************************

Smrt	mvi m,01001011b		; kd smrtc miny
	call StopGame		; zastavm hru v. asu
	lhld AdresaObliceje	; zobraz obliej ""
	lxi d,1+(6*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejBad
	call ShowImage		; vlastn zobrazen ikony
	call KontrolaPole	; korekce chyb
	call ZobrazPole		; zobrazen pole
	jmp SmyckaHryMysOn	; zapnout kurzor myi a ekat
				; na restart obliejem

; ****************************************
; Vhra - odhalil jsem vechny voln buky
; ****************************************

Vyhra	rst 6
	call StopGame		; zastavm hru v. asu
	lhld AdresaObliceje	; zobraz obliej ""
	lxi d,1+(6*64)
	dad d
	xchg			; DE = adresa ve videoram
	lxi h,ImgOblicejHavaj
	call ShowImage		; vlastn zobrazen ikony
	call KontrolaPole	; korekce chyb
	call ZobrazPole		; zobrazen pole

	call TestNaRekord
	jc BylRekord
	lxi h,-1		; odblokovat mechanismus
	shld VolnychBunek	; pro ukonen hry
	jmp SmyckaHryMysOn	; zapnout kurzor myi a ekat
				; na restart obliejem	
BylRekord
	call ZapisRekord
	jmp SpustMenu
