; **********************************
; Vykreslen a obsluha hlavnho menu
; **********************************

DoMenu
	call ModifyMenuText	; modifikace text
				; LEVEL/COLOR/MOUSE
	mvi a,3			; tisk sestavy vodnho menu
	call ZobrazSestavu
DoMenuRelease
	call KeyRelease		; pokat na uvolnn klves
DoMenuLoop
	call MoreRandom		; mchat prbn genertorem

	lxi h,0808h		; test klvesy L(EVEL)
	rst 5
	jz ZmenaLevelu
	lxi h,0310h		; test klvesy C(OLOR)
	rst 5
	jz ZmenaColor
	lxi h,0710h		; test klvesy M(OUSE)
	rst 5
	jz ZmenaMouse
	lxi h,0d10h		; test klvesy L EOL
	rst 5
	rz
	lxi h,0e10h		; test klvesy P EOL
	rst 5
	rz
	lxi h,0704h		; test klvesy I(NFO)
	rst 5
	jz ShowInfo
	jmp DoMenuLoop

; *****************************************
; Inkrementace promnn (HL) v rozsahu 0..A
; *****************************************

IncVariable
	inr m			; inkrementace promnn
	cmp m			; test pekroen maxima
	rnc			; NE => konec
	mvi m,0			; ANO => tm znovu od nuly
	ret

; ************
; zmna levelu
; ************

ZmenaLevelu
	call Chirp		; klik
	mvi a,2			; 3 stavy (0,1,2)
	lxi h,PoleSize		; promnn velikosti pole
	call IncVariable	; cyklicky pepnm
	call ZobrazZvolenyLevel	; vypu text
	jmp DoMenuRelease	; zpt do smyky

; *****************
; zobrazova levelu
; *****************

ZobrazZvolenyLevel
	mvi a,4			; barvu textu "LEVEL"
	call SetCol		; vyberu pro tisk
	lxi h,MenuLev+17
	shld Prnpos		; nastavm pozici tisku
	lda PoleSize		; podle vybran velikosti pole
	lxi h,tbNazvuLevelu	; z tabulky
	rst 3			; vyberu popisn text
	jmp prtstg		; a ten vytisknu

				; nzvy velikost hracho pole
tbNazvuLevelu
	.dw NazevLo,NazevMid,NazevHi
NazevLo
	.db 0,9,_X,0,9,_SPC+80h
NazevMid
	.db 1,5,_X,1,5,_SPC+80h
NazevHi
	.db 2,1,_X,1,6,_SPC+80h

; ********************
; zmna barevnho mdu
; ********************

ZmenaColor
	call Chirp		; klik
	mvi a,3			; 4 stavy (0,1,2,3)
	lxi h,ColorMode		; promnn barevnho reimu
	call IncVariable	; cyklicky pepnm
	call ModifyMenuText	; modifikace text promnnch
	call SetPal		; nastavm novou paletu
	mvi a,4			; tisk sestavy vodnho menu
	call ZobrazSestavu	; do pomocn videoram
	call CopyVideoram	; a tu zkopruje do hlavn
	jmp DoMenuRelease	; zpt do smyky

				; nzvy barevnch reim
NazevMono
	.db _M,_O,_N,_O
NazevRGBM
	.db _R,_G,_B,_M
NazevWGRM
	.db _W,_G,_R,_M
NazevACE
	.db _A,_C,_E,_SPC

; ********************
; zmna nastaven myi
; ********************

ZmenaMouse
	call Chirp		; klik
	mvi a,3			; 4 stavy (0,1,2,3)
	lxi h,MysSensitivity	; promnn citlivosti myi
	call IncVariable	; cyklicky pepnm
	call ZobrazNastaveniMysi ; vypu text
	jmp DoMenuRelease	; zpt do smyky

; *************************
; zobrazova nastaven myi
; *************************

ZobrazNastaveniMysi
	mvi a,6			; barvu textu "MOUSE"
	call SetCol		; vyberu pro tisk
	lxi h,MenuMou+17
	shld Prnpos		; nastavm pozici tisku
	lda MysSensitivity	; podle stupn citlivosti myi
	lxi h,tbNazvuMysi	; z tabulky
	rst 3			; vyberu popisn text
	jmp prtstg		; a ten vytisknu

				; nzvy nastaven myi
tbNazvuMysi
	.dw MouseOFF,MouseSLOW,MouseNORM,MouseFAST
MouseOFF
	.db _O,_F,_F,_SPC,_SPC+80h
MouseSLOW
	.db _S,_L,_O,_W,_SPC+80h
MouseNORM
	.db _N,_O,_R,_M,_SPC+80h
MouseFAST
	.db _F,_A,_S,_T,_SPC+80h

; ***********************************
; Modifikuje text menu dle promnnch
; ***********************************

ModifyMenuText
	lda PoleSize		; do sestavy MENU pedtiskne
	lxi h,tbNazvuLevelu	; volbu LEVEL
	rst 3
	lxi d,txtLevelValue
	mvi c,5
	rst 1

	lda ColorMode		; do sestavy MENU pedtiskne
	add a
	add a
	lxi h,NazevMono		; volbu COLOR
	rst 2
	lxi d,txtColorValue
	mvi c,4
	rst 1

	lda MysSensitivity	; do sestavy MENU pedtiskne
	lxi h,tbNazvuMysi	; volbu MYS
	rst 3
	lxi d,txtMouseValue
	mvi c,4
	rst 1

	ret
