; ****************************************************
; Tisk etzce, posledn znak m nastaven atribut 80h.
; vstup: HL = adresa zatku etzce znak
; ****************************************************

prtstg:	mov a,m		; nast aktuln znak
	ani 7fh		; odmaskovat platn bity
	call prtchr	; znak vytisknout (vrac ACC=0)
	ora m		; test MSB tohoto znaku
	inx h		; posun na dal znak etzce
	jp prtstg	; pokud znak neml 80h, tisk dalho 
	ret		; jinak konec

; **********************************************
; Pedpony pro tisk cifer ve formtu packed BCD.
; **********************************************

pr6_hi:	rrc		; tisk hornho nibble
	rrc
	rrc
	rrc
pr6_lo:	ani 0fh		; tisk spodnho nibble

; *********************************************
; Tisk znaku v rastru 9x8 pixel.
; vstup: ACC = kd znaku 0..63
;        (prnpos) = adresa tisku do videoram
;         MSB = MSB adresy videoram (defacto Y)
;         LSB = pozice tisku X (0..31)
; *********************************************

prtchr:	push h		; uschovat HL kvli adresaci znaku

	lxi h,0		; uschovat stav reg. SP
	dad sp
	shld prtchrSP+1

	mov b,a		; B := A (= kd znaku)
	lxi d,tbFont	; bze tabulky fontu
	add a		; A := 2x kd znaku
	add b		; A := 3x kd znaku
	mov l,a		; HL := 3x kd znaku
	mvi h,0
	dad h		; HL := 6x kd znaku
	dad h		; HL := 12x kd znaku
	dad d		; HL := kompletn adresa pedlohy znaku
	xchg		; DE := kompletn adresa pedlohy znaku
	
	lxi sp,-(7*64)-1 ; SP := dkova

	lda ColAtr+0	; C := LSB atributu barvy 
	mov c,a

	lhld Prnpos	; HL := adresa tisku do videoram
	mov a,l
	rar		; ACC := X/2, CY := sud/lich pozice
	push psw	; uschovat CY (sud/lich pozice)
	add l		; ACC := 1,5X
	inr l		; posun kurzoru
	shld Prnpos	; a uloen nov tiskov pozice
	mov l,a		; HL := finln adresa ve videoram
	pop psw		; obnovit stav CY (sud/lich pozice)
	jc prt2nd	; skok pro lich pozice
	
; tisk na sud tiskov pozice

prt1st:	ldax d		; pedloha 0. linky znaku (0/1/2/3)
	ani 3fh		; odmaskovat 6 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt nast pedlohov bajt
	ral		; posunout
	ral		; na pozici
	ral
	ani 3		; odmaskovat zbyl 2 pixely
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal linka pedlohy
	
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; nyn v opanm smru zprava doleva
	ral		; tisknu 4. linku znaku (4/5/6/7)
	ral		; po posunu na pozici
	ral
	ani 3		; odmaskuju 2 pixely vpravo
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapu do pravho bajtu videoram
	dcr l		; posun na lev bajt
	ldax d		; opt natu pedlohov bajt
	ani 3fh		; ponechm z nj 6 levch pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapu do levho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal pedlohov bajt znaku

	ldax d		; pedloha 8. linky znaku (8/9/10/11)
	ani 3fh		; odmaskovat 6 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt nast pedlohov bajt
	ral		; posunout
	ral		; na pozici
	ral
	ani 3		; odmaskovat zbyl 2 pixely
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	dad sp		; nvrat o 8 mikrodk ve
	inx d		; dal linka pedlohy

	lda ColAtr+1	; po kadm mikrodku
	sta ColAtr+0	; prohodm dvojici atribut Colorace
	mov b,a
	mov a,c
	sta ColAtr+1
	mov c,b

	mov a,l		; za pedpokladu, e tiskov dky
	ani 0c0h	; zanaj na linkch dlitelnch osmi,
	jnz prt1st	; funguje toto jako NEXT linka
	jmp prtchrCommon	

; tisk na lich tiskov pozice

prt2nd:	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; pedloha 0. linky znaku (0/1/2/3)
	rlc		; posunout na pozici
	rlc
	rlc
	ani 38h		; odmaskovat 3 pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	ldax d		; opt nast pedlohov bajt
	rrc		; posunout
	rrc		; na pozici
	rrc
	ani 1fh		; odmaskovat zbylch 5 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal linka pedlohy
	
	ldax d		; nyn v opanm smru zprava doleva
	rrc		; tisknu 4. linku znaku (4/5/6/7)
	rrc		; po posunu na pozici
	rrc
	ani 1fh		; odmaskuju 5 pixel vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapu do pravho bajtu videoram
	dcr l		; posun na lev bajt
	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt natu pedlohov bajt
	rlc		; posunu pixely na pozici
	rlc
	rlc
	ani 38h		; ponechm z nj 3 lev pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapu do levho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal pedlohov bajt znaku
	
	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; pedloha 8. linky znaku (8/9/10/11)
	rlc		; posunout na pozici
	rlc
	rlc
	ani 38h		; odmaskovat 3 pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	ldax d		; opt nast pedlohov bajt
	rrc		; posunout
	rrc		; na pozici
	rrc
	ani 1fh		; odmaskovat zbylch 5 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	dad sp		; nvrat o 8 mikrodk ve
	inx d		; dal linka pedlohy

	lda ColAtr+1	; po kadm mikrodku
	sta ColAtr+0	; prohodm dvojici atribut Colorace
	mov b,a
	mov a,c
	sta ColAtr+1
	mov c,b

	mov a,l		; za pedpokladu, e tiskov dky
	ani 0c0h	; zanaj na linkch dlitelnch osmi,
	jnz prt2nd	; funguje toto jako NEXT linka
prtchrCommon
	xchg		; pro ely uchovn adresy tisku
prtchrSP
	lxi sp,0
	pop h
	ret

; *********************************************
; Tisk inverznho znaku v rastru 9x8 pixel.
; vstup: ACC = kd znaku 0..63
;        (prnpos) = adresa tisku do videoram
;         MSB = MSB adresy videoram (defacto Y)
;         LSB = pozice tisku X (0..31)
; Procedura invertuje vybran pozice ve znaku.
; Ureno pouze pro blikajc editan kurzor.
; *********************************************

PrtInv	push h		; uschovat HL kvli adresaci znaku

	lxi h,0		; uschovat stav reg. SP
	dad sp
	shld prtchrSP+1

	mov b,a		; B := A (= kd znaku)
	lxi d,tbFont	; bze tabulky fontu
	add a		; A := 2x kd znaku
	add b		; A := 3x kd znaku
	mov l,a		; HL := 3x kd znaku
	mvi h,0
	dad h		; HL := 6x kd znaku
	dad h		; HL := 12x kd znaku
	dad d		; HL := kompletn adresa pedlohy znaku
	xchg		; DE := kompletn adresa pedlohy znaku
	
	lxi sp,-(7*64)-1 ; SP := dkova

	lda ColAtr+0	; C := LSB atributu barvy 
	mov c,a

	lhld Prnpos	; HL := adresa tisku do videoram
	mov a,l
	rar		; ACC := X/2, CY := sud/lich pozice
	push psw	; uschovat CY (sud/lich pozice)
	add l		; ACC := 1,5X
	inr l		; posun kurzoru
	shld Prnpos	; a uloen nov tiskov pozice
	mov l,a		; HL := finln adresa ve videoram
	pop psw		; obnovit stav CY (sud/lich pozice)
	jc PrtInv2nd	; skok pro lich pozice
	
; tisk na sud tiskov pozice

PrtInv1st
	ldax d		; pedloha 0. linky znaku (0/1/2/3)
	cma
	ani 3fh		; odmaskovat 6 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt nast pedlohov bajt
	cma
	ral		; posunout
	ral		; na pozici
	ral
	ani 3		; odmaskovat zbyl 2 pixely
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal linka pedlohy
	
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; nyn v opanm smru zprava doleva
	cma
	ral		; tisknu 4. linku znaku (4/5/6/7)
	ral		; po posunu na pozici
	ral
	ani 3		; odmaskuju 2 pixely vpravo
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapu do pravho bajtu videoram
	dcr l		; posun na lev bajt
	ldax d		; opt natu pedlohov bajt
	cma
	ani 3fh		; ponechm z nj 6 levch pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapu do levho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal pedlohov bajt znaku

	ldax d		; pedloha 8. linky znaku (8/9/10/11)
	cma
	ani 3fh		; odmaskovat 6 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	mov a,m		; ponechat 3 bity pravho znaku
	ani 38h
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt nast pedlohov bajt
	cma
	ral		; posunout
	ral		; na pozici
	ral
	ani 3		; odmaskovat zbyl 2 pixely
	ora b		; pidat bity znaku vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	dad sp		; nvrat o 8 mikrodk ve
	inx d		; dal linka pedlohy

	lda ColAtr+1	; po kadm mikrodku
	sta ColAtr+0	; prohodm dvojici atribut Colorace
	mov b,a
	mov a,c
	sta ColAtr+1
	mov c,b

	mov a,l		; za pedpokladu, e tiskov dky
	ani 0c0h	; zanaj na linkch dlitelnch osmi,
	jnz PrtInv1st	; funguje toto jako NEXT linka
	jmp prtchrCommon	

; tisk na lich tiskov pozice

PrtInv2nd
	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; pedloha 0. linky znaku (0/1/2/3)
	cma
	rlc		; posunout na pozici
	rlc
	rlc
	ani 38h		; odmaskovat 3 pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	ldax d		; opt nast pedlohov bajt
	cma
	rrc		; posunout
	rrc		; na pozici
	rrc
	ani 1fh		; odmaskovat zbylch 5 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal linka pedlohy
	
	ldax d		; nyn v opanm smru zprava doleva
	cma
	rrc		; tisknu 4. linku znaku (4/5/6/7)
	rrc		; po posunu na pozici
	rrc
	ani 1fh		; odmaskuju 5 pixel vpravo
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapu do pravho bajtu videoram
	dcr l		; posun na lev bajt
	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; opt natu pedlohov bajt
	cma
	rlc		; posunu pixely na pozici
	rlc
	rlc
	ani 38h		; ponechm z nj 3 lev pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapu do levho bajtu videoram
	inr h		; pesun o 4 mikrodky ne
	inx d		; dal pedlohov bajt znaku
	
	mov a,m		; ponechat 3 bity levho znaku
	ani 7
	ora c		; pidat atribut barvy Colorace
	mov b,a		; uschovat mezivsledek do B
	ldax d		; pedloha 8. linky znaku (8/9/10/11)
	cma
	rlc		; posunout na pozici
	rlc
	rlc
	ani 38h		; odmaskovat 3 pixely
	ora b		; ponechm pixely pedchozho znaku!
	mov m,a		; zapsat do videoram
	inr l		; posunout se o bajt vpravo
	ldax d		; opt nast pedlohov bajt
	cma
	rrc		; posunout
	rrc		; na pozici
	rrc
	ani 1fh		; odmaskovat zbylch 5 pixel
	ora c		; pidat atribut barvy Colorace
	mov m,a		; a zapsat do pravho bajtu videoram
	dad sp		; nvrat o 8 mikrodk ve
	inx d		; dal linka pedlohy

	lda ColAtr+1	; po kadm mikrodku
	sta ColAtr+0	; prohodm dvojici atribut Colorace
	mov b,a
	mov a,c
	sta ColAtr+1
	mov c,b

	mov a,l		; za pedpokladu, e tiskov dky
	ani 0c0h	; zanaj na linkch dlitelnch osmi,
	jnz PrtInv2nd	; funguje toto jako NEXT linka
	jmp prtchrCommon	

; ******************************************************
; Mapa znak pro formt 9x12 pixel se stdavm azenm
; linek v poad: 0-4-8-1-5-9-2-6-10-3-7-11
; ******************************************************

tbFont:
;    0    4    8    1    5    9    2    6    10   3    7    11 

; 0
.db 000h,099h,0c3h,07eh,089h,0ffh,0ffh,091h,07eh,0c3h,099h,000h
; 1
.db 000h,0e3h,0c3h,07eh,0e7h,0ffh,0ffh,0e7h,07eh,0e7h,0e7h,000h
; 2
.db 000h,099h,081h,07eh,09fh,0ffh,0ffh,0c3h,07eh,0c3h,0f9h,000h
; 3
.db 000h,099h,0c3h,07eh,0cfh,0ffh,0ffh,09fh,07eh,0c3h,099h,000h
; 4
.db 000h,0f3h,0cfh,07eh,0f9h,0ffh,0ffh,0c9h,07eh,0e7h,081h,000h
; 5
.db 000h,0f9h,0c3h,07eh,0c1h,0ffh,0ffh,09fh,07eh,081h,099h,000h
; 6
.db 000h,0f9h,0c3h,07eh,0c1h,0ffh,0ffh,099h,07eh,0c3h,099h,000h
; 7
.db 000h,09fh,0e7h,07eh,09fh,0ffh,0ffh,0cfh,07eh,081h,0e7h,000h
; 8
.db 000h,099h,0c3h,07eh,0c3h,0ffh,0ffh,099h,07eh,0c3h,099h,000h
; 9
.db 000h,099h,0c3h,07eh,099h,0ffh,0ffh,083h,07eh,0c3h,09fh,000h
; A (0ah)
.db 000h,099h,099h,07eh,099h,0ffh,0ffh,099h,07eh,0c3h,081h,000h
; B (0bh)
.db 000h,099h,0c1h,07eh,0c1h,0ffh,0ffh,099h,07eh,0c1h,099h,000h
; C (0ch)
.db 000h,099h,0c3h,07eh,0f9h,0ffh,0ffh,0f9h,07eh,0c3h,099h,000h
; D (0dh)
.db 000h,099h,0c1h,07eh,099h,0ffh,0ffh,099h,07eh,0c1h,099h,000h
; E (0eh)
.db 000h,0f9h,081h,07eh,0c1h,0ffh,0ffh,0f9h,07eh,081h,0f9h,000h
; F (0fh)
.db 000h,0f9h,0f9h,07eh,0c1h,0ffh,0ffh,0f9h,07eh,081h,0f9h,000h
; G (10h)
.db 000h,099h,0a3h,07eh,0f9h,0ffh,0ffh,081h,07eh,0c3h,099h,000h
; H (11h)
.db 000h,099h,099h,07eh,099h,0ffh,0ffh,081h,07eh,099h,099h,000h
; I (12h)
.db 000h,0e7h,0c3h,07eh,0e7h,0ffh,0ffh,0e7h,07eh,0c3h,0e7h,000h
; J (13h)
.db 000h,09fh,0c3h,07eh,09fh,0ffh,0ffh,09fh,07eh,083h,099h,000h
; K (14h)
.db 000h,0c9h,099h,07eh,0e1h,0ffh,0ffh,0e1h,07eh,099h,0c9h,000h
; L (15h)
.db 000h,0f9h,081h,07eh,0f9h,0ffh,0ffh,0f9h,07eh,0f9h,0f9h,000h
; M (16h)
.db 000h,081h,099h,07eh,0a5h,0ffh,0ffh,0bdh,07eh,099h,099h,000h
; N (17h)
.db 000h,091h,099h,07eh,081h,0ffh,0ffh,089h,07eh,099h,099h,000h
; O (18h)
.db 000h,099h,0c3h,07eh,099h,0ffh,0ffh,099h,07eh,0c3h,099h,000h
; P (19h)
.db 000h,099h,0f9h,07eh,099h,0ffh,0ffh,099h,07eh,0c1h,0c1h,000h
; Q (1Ah)
.db 000h,099h,093h,07eh,099h,0ffh,0ffh,0a9h,07eh,0c3h,0c9h,000h
; R (1Bh)
.db 000h,099h,099h,07eh,099h,0ffh,0ffh,081h,07eh,0c1h,0c9h,000h
; S (1Ch)
.db 000h,0f9h,0c3h,07eh,0c3h,0ffh,0ffh,09fh,07eh,0c3h,099h,000h
; T (1Dh)
.db 000h,0e7h,0e7h,07eh,0e7h,0ffh,0ffh,0e7h,07eh,081h,0e7h,000h
; U (1Eh)
.db 000h,099h,0c3h,07eh,099h,0ffh,0ffh,099h,07eh,099h,099h,000h
; V (1Fh)
.db 000h,099h,0f3h,07eh,099h,0ffh,0ffh,0c9h,07eh,099h,0e1h,000h
; W (20h)
.db 000h,099h,099h,07eh,0bdh,0ffh,0ffh,0a5h,07eh,099h,081h,000h
; X (21h)
.db 000h,091h,099h,07eh,0e3h,0ffh,0ffh,0c7h,07eh,099h,089h,000h
; Y (22h)
.db 000h,099h,0e7h,07eh,099h,0ffh,0ffh,0c3h,07eh,099h,0e7h,000h
; Z (23h)
.db 000h,09fh,081h,07eh,0c7h,0ffh,0ffh,0f3h,07eh,081h,0f9h,000h
; : (24h)
.db 000h,0e7h,0e7h,07eh,0e7h,0ffh,0ffh,0ffh,07eh,0ffh,0e7h,000h
; - (25h)
.db 000h,0ffh,0ffh,07eh,0ffh,0ffh,0ffh,0c3h,07eh,0ffh,0ffh,000h
; SPC teka (26h)
.db 000h,000h,010h,000h,000h,000h,000h,000h,000h,000h,000h,000h
; , (27h)
.db 000h,0ffh,0e7h,07eh,0ffh,0f3h,0ffh,0ffh,07eh,0ffh,0e7h,000h
; . (28h)
.db 000h,0ffh,0e7h,07eh,0ffh,0ffh,0ffh,0ffh,07eh,0ffh,0e7h,000h
; ! (29h)
.db 000h,0e7h,0e7h,07eh,0e7h,0ffh,0ffh,0e7h,07eh,0e7h,0ffh,000h
; / (2Ah)
.db 000h,09fh,0f9h,07eh,0cfh,0ffh,0ffh,0e7h,07eh,0ffh,0f3h,000h
; SPC tverec (2Bh)
.db 000h,0ffh,0ffh,07eh,0ffh,0ffh,0ffh,0ffh,07eh,0ffh,0ffh,000h
; nic (2Ch)
.db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
; uvozovky (2Dh)
.db 000h,093h,0ffh,07eh,0b7h,0ffh,0ffh,0ffh,07eh,093h,0ffh,000h
; # (2Eh)
.db 000h,0d7h,0d7h,07eh,083h,0ffh,0ffh,0d7h,07eh,0ffh,083h,000h
; $ (2Fh)
.db 000h,087h,0c3h,07eh,0ebh,0efh,0ffh,0c7h,07eh,0efh,0afh,000h
; % (30h)
.db 000h,0d9h,0cdh,07eh,0e9h,0ffh,0ffh,0f7h,07eh,0ffh,0cbh,000h
; & (31h)
.db 000h,0e9h,093h,07eh,0f3h,0ffh,0ffh,0a5h,07eh,0f3h,0cdh,000h
; apostrof (32h)
.db 000h,0cfh,0ffh,07eh,0dfh,0ffh,0ffh,0ffh,07eh,0cfh,0ffh,000h
; lev kulat zvorka (33h)
.db 000h,0e7h,0cfh,07eh,0e7h,0dfh,0dfh,0e7h,07eh,0cfh,0e7h,000h
; prav kulat zvorka (34h)
.db 000h,0e7h,0f3h,07eh,0e7h,0fbh,0fbh,0e7h,07eh,0f3h,0e7h,000h
; _ (35h)
.db 000h,0ffh,081h,07eh,0ffh,0ffh,0ffh,0ffh,07eh,0ffh,0ffh,000h
; = (36h)
.db 000h,0ffh,0ffh,07eh,0c3h,0ffh,0ffh,0ffh,07eh,0ffh,0c3h,000h
; } (37h)
.db 000h,0e7h,0e7h,07eh,0cfh,0f3h,0f3h,0cfh,07eh,0e7h,0e7h,000h
; { (38h)
.db 000h,0e7h,0e7h,07eh,0f3h,0cfh,0cfh,0f3h,07eh,0e7h,0e7h,000h
; @ (39h)
.db 000h,099h,083h,07eh,089h,0ffh,0ffh,089h,07eh,0c3h,0f9h,000h
; ` (3Ah)
.db 000h,0f3h,0ffh,07eh,0fbh,0ffh,0ffh,0ffh,07eh,0f3h,0ffh,000h
; \ (3Bh)
.db 000h,0f9h,09fh,07eh,0f3h,0ffh,0ffh,0e7h,07eh,0ffh,0cfh,000h
; ^ (3Ch)
.db 000h,093h,0ffh,07eh,0ffh,0ffh,0efh,0ffh,07eh,0c7h,0ffh,000h
; ; (3Dh)
.db 000h,0e7h,0e7h,07eh,0e7h,0f3h,0ffh,0ffh,07eh,0ffh,0e7h,000h
; ] (3Eh)
.db 000h,0cfh,0c3h,07eh,0cfh,0ffh,0ffh,0cfh,07eh,0c3h,0cfh,000h
; [ (3Fh)
.db 000h,0f3h,0c3h,07eh,0f3h,0ffh,0ffh,0f3h,07eh,0c3h,0f3h,000h
; * (40h)
.db 000h,0efh,0efh,07eh,0abh,0ffh,0ffh,0c7h,07eh,0ffh,0abh,000h
; + (41h)
.db 000h,0e7h,0e7h,07eh,0e7h,0ffh,0ffh,081h,07eh,0ffh,0e7h,000h
; < (42h)
.db 000h,0cfh,0cfh,07eh,0e7h,0ffh,0ffh,0f3h,07eh,0ffh,0e7h,000h
; > (43h)
.db 000h,0f3h,0f3h,07eh,0e7h,0ffh,0ffh,0cfh,07eh,0ffh,0e7h,000h
; ? (44h)
.db 000h,099h,0e7h,07eh,0cfh,0ffh,0ffh,0e7h,07eh,0c3h,0ffh,000h

;    0    4    8    1    5    9    2    6    10   3    7    11 
