; ******************************************
; Inicializace promnnch po startu programu
; ******************************************

InitProg
	#ifdef INIT_TEST
	mvi a,2
	sta PoleSize		; vchoz velikost hracho pole
	mvi a,1
	sta MysSensitivity	; vchoz nastaven myi
	mvi a,3
	sta ColorMode		; vchoz barevn reim
	#else
	xra a
	sta PoleSize		; vchoz velikost hracho pole
	sta MysSensitivity	; vchoz nastaven myi
	sta ColorMode		; vchoz barevn reim
	#endif
	jmp SetPal

; ***************************************************
; Nastaven promnn hry vetn rozmr minovho pole
; ***************************************************

NastavHru
	lda PoleSize
	lxi h,tbNastaveniHry
	rst 3
	lxi d,F_Left		; 1. sadu promnnch
	mvi c,16
	rst 1			; zkoprovat
	lxi d,VolnychBunek	; 2. sadu promnnch
	mvi c,16
	rst 1			; zkoprovat

	xra a		; vynulovat as a aktivovat hru
	sta Time+0
	sta Time+1
	sta Time+2
	mvi a,2		; peddlika 500ms
	sta Time+3
	sta TimeRun	; as b
	sta GameOver	; hra b
	ret

tbNastaveniHry
	.dw NastaveniHry0,NastaveniHry1,NastaveniHry2

NastaveniHry0
	.db 7		;  7 = slo prvn buky zleva
	.db 16		; 16 = slo posledn buky +1
	.db 4		;  4 = slo prvn buky shora
	.db 13		; 13 = slo posledn buky +1
	.dw POCET_MIN_L0
			; poet min ve he
	.dw 0d013h	; pozice tisku asu v zhlav
	.dw 0d00ah	; pozice tisku zbylch min v zhlav
	.db 136		; pixelov pozice oblieje X
	.db 62		; pixelov pozice oblieje Y
	.dw 0cf16h	; adresa oblieje ve videoram
	.dw 0cd1ah	; adresa asu ve videoram
	.dw 9*9-POCET_MIN_L0
			; poet volnch bunk

NastaveniHry1
	.db 4		;  4 = slo prvn buky zleva
	.db 19		; 19 = slo posledn buky +1
	.db 0		;  0 = slo prvn buky shora
	.db 15		; 15 = slo posledn buky +1
	.dw POCET_MIN_L1
			; poet min ve he
	.dw 0c217h	; pozice tisku asu v zhlav
	.dw 0c206h	; pozice tisku zbylch min v zhlav
	.db 136		; pixelov pozice oblieje X
	.db 6		; pixelov pozice oblieje Y
	.dw 0c116h	; adresa oblieje ve videoram
	.dw 0bf20h	; adresa asu ve videoram
	.dw 15*15-POCET_MIN_L1
			; poet volnch bunk

NastaveniHry2
	.db 1		;  1 = slo prvn buky zleva
	.db 22		; 22 = slo posledn buky +1
	.db 0		;  0 = slo prvn buky shora
	.db 16		; 16 = slo posledn buky +1
	.dw POCET_MIN_L2
			; poet min ve he
	.dw 0c21bh	; pozice tisku asu v zhlav
	.dw 0c202h	; pozice tisku zbylch min v zhlav
	.db 136		; pixelov pozice oblieje X
	.db 6		; pixelov pozice oblieje Y
	.dw 0c116h	; adresa oblieje ve videoram
	.dw 0bf26h	; adresa asu ve videoram
	.dw 21*16-POCET_MIN_L2
			; poet volnch bunk

; *****************************************
; Nastav pohybov limity myi podle LEVELu
; *****************************************

SetMouseWindow
	lda PoleSize		; nate kd LEVELu 0..2
	add a
	add a
	add a
	lxi h,tbMysichDorazu	; z tabulky limit souadnic
	rst 2
	push h
	lxi d,MysXMin		; do aktulnch limit myi
	mvi c,8			; o dlce 8 bajt
	rst 1			; nakopruje data
	pop h
	lxi b,14
	call AddOfsetToHL
	shld MysX
	xchg
	inx h
	inx h
	inx h
	lxi b,27
	call AddOfsetToHL
	shld MysY
	ret

AddOfsetToHL
	mov e,m
	inx h
	mov d,m
	xchg
	dad b
	ret
	
tbMysichDorazu	
	.dw 83,198,59,199	; Xmin,Xmax,Ymin,Ymax pro 9x9
	.dw 47,234,3,227	; Xmin,Xmax,Ymin,Ymax pro 15x15
	.dw 11,270,3,241	; Xmin,Xmax,Ymin,Ymax pro 21x16

; ****************************************************
; Pok na uvolnn vech klves v aktivovanm sloupci
; ****************************************************

KeyRelease
	lxi b,1000	; klvesa mus bt uvolnna
KeyReleaseWait
	in kbdin	; nast dkov odezvy klvesnice
	ori 80h		; odmaskovat nevyuit bit
	inr a		; test na vechny dky nestisknuty
	jnz KeyRelease	; nco je stisknuto, ekm na uvolnn
	dcx b		; nic nen stisknuto,
	mov a,b		; odpotvm poadovanou dobu
	ora c		; pro detekci defitivnho uvolnn
	jnz KeyReleaseWait ; vech klves ve vybranm sloupci
	ret

; ****************************************************
; Pok na uvolnn mych tlatek, zatmco as plyne
; ****************************************************

MouseKeyRelease
	lxi b,200	; tlatka mus bt uvolnna
MouseKeyReleaseWait
	in kbdin	; STOPka vldne vem
	add a
	rp
	in uartcwr	; test plynut asu
	ani 4
	cnz ZmenaCasu

	in mysport	; nast stav tlatek myi
MouseKeyReleaseModA
	ani 0c0h	; odmaskovat nevyuit bity
	jnz MouseKeyRelease
	mvi a,0dh	; test DEL aka L tlatko
	out kbdout
	in kbdin
MouseKeyReleaseModB
	ani 2
	jz MouseKeyRelease
	mvi a,0eh	; test CLR aka P tlatko
	out kbdout
	in kbdin
MouseKeyReleaseModC
	ani 2
	jz MouseKeyRelease
			; nco je stisknuto, ekm na uvolnn
	dcx b		; nic nen stisknuto,
	mov a,b		; odpotvm poadovanou dobu
	ora c		; pro detekci defitivnho uvolnn
	jnz MouseKeyReleaseWait
			; vech klves ve vybranm sloupci
	ret

; ******************************************************
; Zobraz poet zbylch min do stavovho dku (zhlav)
; ******************************************************

ZobrazPocetZbylychMin
	mvi a,10
	call SetCol
	lhld PozicePoctuMin
	shld Prnpos

	lhld ZbytekMin
	mov a,h
	ana a
	mvi a,_SPC
	jp ZobrazPocetKladnychMin
	call NegHL
	mvi a,_MIN

ZobrazPocetKladnychMin
	call prtchr	; ppadn znamnko
	lxi d,100
	rst 4
	jc ZobrazPocetMin99
	lxi h,99
ZobrazPocetMin99
	mov h,l
	call b7bcd
	push psw
	call pr6_hi
	pop psw
	jmp pr6_lo

; *****************************************
; omezen pevod 8-bitovho binrnho sla
; z reg. H na BCD slo v reg. A (00..99)
; *****************************************
; vstup:  H = binrn slo (00h..63h)
; vstup: A = BCD hodnota (00..99)
; *****************************************

b7bcd:	mvi b,7		; pevdm 7-bitov slo
	xra a		; pprava akumultoru vsledku
	dad h
cykl7:	dad h		; posun H vlevo, CY = H[7]
	adc a		; A := 2 x A + CY
	daa		; dekadick korekce
	dcr b
	jnz cykl7	; NEXT bit
	ret

; *********
; Negace HL
; *********

NegHL
	mov a,h		; vpoet dvojkovho doplku HL
	cma		; neboli nsoben krt (-1)
	mov h,a
	mov a,l
	cma
	mov l,a
	inx h
	ret

; ****************************************
; Nabourn sekvence pseudonhodnch sel
; ****************************************

MoreRandom
	push h
	lxi h,Randomize+1
	in ctc2ch	; podle sekundovho tae T2
	xra m		; XORuj doplkov faktor nhody
	inr a
	mov m,a
	pop h
	ret

; ***************************************************
; Genertor pseudonhodnch sel (16-bitov registr)
; zptnovazebn polynom: X[16]+X[15]+X[13]+X[4]+1
; maska vpotu polynomu: 1101 0000 0000 1000 (D008h)
; ***************************************************

GetRandom
	push b		; i kdy by stail 8-bitov genertor,
	push h		; kvli delch sekvenc pouiju ten
RandomNumber		; 16-bitov
	lxi h,0		; z pedchozho sla
	mov a,h		; z vyho bajtu
	ani 0d0h	; vypotu hodnotu dlho
	mov b,a		; polynomu a ulom ji do B
	mov a,l		; rovn z niho bajtu
	ani 008h	; vypotu dl polynom
	xra b		; a sloum z mezivsledkem z B
	dad h		; pedchoz slo v HL posouvm vlevo
	jpo rnd16c	; a hodnotu celho generujcho polynomu
	inx h		; nasunu do registru HL zprava
rnd16c	shld RandomNumber+1
			; ulom novou hodnotu sla
	mov a,l		; pouvm jen LSB
Randomize
	adi 0		; doplkov faktor nhody
	pop h
	pop b
	ret

; *************************
; vodn inicializace port
; *************************

SetIO	lxi h,tbSetIO	; data pro inicializaci port
SetIOLoop
	mov a,m		; nast slo portu
	inx h		; posun na dal bajt
	sta SetIOPort+1	; slo portu ulom do instrukce OUT
	inr a		; pozdji vyhodnotm port 0ffh
	mov a,m		; natu hodnotu pro zpis na port
	inx h		; posun na dal bajt
SetIOPort
	out 0ffh	; vlastn zpis na zvolen port
	jnz SetIOLoop	; pokud nebyl port 0ffh, jedu dl
	ret		; (port 0ffh je vtinou neobsazen,
			; take posledn zpis na nj nevad)
tbSetIO
	.db kbdcwr,82h	; AllRAM reim
	.db ctccwr,076h	; reim tae T1 8253
	.db ctc1ch,0abh	; LO(1200Hz)
	.db ctc1ch,006h	; HI(1200Hz)
	.db ctccwr,094h	; reim tae T2 8253
	.db ctc2ch,000h	; LSB only, MODE#3, BIN
	.db uartcwr,80h	; sekvence reset UARTu 8251
	.db uartcwr,80h	; sekvence reset UARTu 8251
	.db uartcwr,40h	; sekvence reset UARTu 8251
	.db uartcwr,13h	; timeout 480ms
	.db uartcwr,23h	; povolit handshake
	.db uartdat,00h	; prvotn start vyslae
	.db 0ffh	; konec seznamu port

; *******************************************************
; Porovn dosaen as s rekordem pro danou velikost pole
; vstup: promnn Time = dosaen as
;        promnn PoleSize = velikost pole
; vstup: DE = ukazatel na rekord
;         CY=1 => nov rekord
; *******************************************************

TestNaRekord
	lda PoleSize		; podle velikosti minovho pole
	dcr a			; vyberu do DE adresu
	lxi d,txtBestP1Time	; se zznamem asu
	jm TestNaRekordSrovnej
	lxi d,txtBestP2Time
	jz TestNaRekordSrovnej
	lxi d,txtBestP3Time
TestNaRekordSrovnej
	mov h,d			; zloha pro koprovn asu
	mov l,e
	lxi b,Time		; vlastn test podkroen asu
	ldax b
	cmp m
	rnz
	inx h
	inx b
	ldax b
	cmp m
	rnz
	inx h
	inx b
	ldax b
	cmp m
	ret

; ***********************************
; Zape rekord a edituje jmno hre
; ***********************************

ZapisRekord
	lxi h,Time		; zkopruje as od HL
	mvi c,3			; na adresu DE
	rst 1			; v dlce 3 znaky

	call ZadejJmeno		; edituje jmno do buferu

	lda PoleSize		; vybere adresu jmna
	dcr a			; podle velikosti minovho pole
	lxi d,txtBestP1Name
	jm ZapisRekordCopy
	lxi d,txtBestP2Name
	jz ZapisRekordCopy
	lxi d,txtBestP3Name
ZapisRekordCopy
	lxi h,txtJmeno		; a zkopruje
	mvi c,6			; 6 znak
	rst 1			; z buferu do vybranho jmna
	ret

; ***********************************
; Alternativn ovlada hry klvesnic
; ***********************************

KbdOvladac
	xra a			; pekreslovn kurzoru bude
	sta MysXCHG		; eeno zde, proto vynuluji
				; signalizaci "zmna pozice"

	call KbdOvladacInkey	; ten klvesnice s funkc
	inr a			; autorepeat
	lxi h,tbKbdOvladac	; pevst na adresu obslun
	rst 3			; rutiny
	pchl			; a tuto zavolat
	
tbKbdOvladac
	.dw KbdOvladacNull	; FFh => dn klvesa
	.dw KbdOvladacLeft	; 00h => kurzor vlevo
	.dw KbdOvladacRight	; 01h => kurzor vpravo
	.dw KbdOvladacUp	; 02h => kurzor nahoru
	.dw KbdOvladacDown	; 03h => kurzor dol

KbdOvladacLeft
	lhld MysXMin		; DE = Xmin+6
	lxi b,6
	dad b
	xchg
	lhld MysX		; posun o 12 pix vlevo
	lxi b,-12
	dad b
	rst 4			; jsem v minovm poli?
	jc KbdOvladacNull	; NE => test L+P "tlatka"
KbdOvladacHorizontal
	shld MysX		; ANO => uloit novou pozici
KbdOvladacVertical
	call Chirp		; jet zvuk
	rst 6			; vypnout kurzor myi
	rst 7			; a zapnout jej na nov pozici

KbdOvladacNull
	lxi h,0d02h		; test DELETE (=L tlatko)
	rst 5
	mvi c,01000000b
	jz KbdOvladacButton
	lxi h,0e02h		; test CLR (=P tlatko)
	rst 5
	mvi c,10000000b
	jz KbdOvladacButton
	mvi c,0
KbdOvladacButton
	mov a,c			; ven z ovladae dodm stav
	add a			; simulovanch tlatek L+P
	ret

KbdOvladacRight
	lhld MysXMax		; DE = Xmax
	xchg
	lhld MysX		; posun o 12 pixel vpravo
	lxi b,12
	dad b
	rst 4			; jsem v minovm poli?
	jnc KbdOvladacNull	; NE => test L+P "tlatka"
	jmp KbdOvladacHorizontal

KbdOvladacUp
	lhld MysYMin		; tot pro kurzor nahoru
	lxi b,20
	dad b
	xchg
	lhld MysY
	lxi b,-14
	dad b
	rst 4
	jc KbdOvladacNull
	shld MysY
	jmp KbdOvladacVertical

KbdOvladacDown
	lhld MysYMax		; tot pro kurzor dol
	xchg
	lhld MysY
	lxi b,14
	dad b
	rst 4
	jnc KbdOvladacNull
	shld MysY
	jmp KbdOvladacVertical

; **********************************************
; Ovlada klvesnice vetn funkce autorepeat.
; V ACC vrac kd klvesy 0..3 nebo 0FFh (NoKey)
; **********************************************

KbdOvladacInkey
	call KbdOvladaniScan
			; zkladn scan klvesnice
	mov a,b
	cpi 0ffh	; byl stisk?
	jnz KbdOvladacPress
			; nco bylo stisknuto
	lxi h,RptKad	; zplata pro run fast repeat
	mov a,m
	ana a
	mvi a,0ffh
	rz
	dcr m
	rnz
	sta KbdOvladacPress+1
			; LastKey = NoKey
	ret

KbdOvladacPress
	cpi 0		; trv stisk klvesy?
	lxi h,RptDly
	jz KbdOvladacRepeat
			; pak b na autorepeat
	sta KbdOvladacPress+1
			; kdy je zmna, LastKey = NewKey
	mvi m,KBDCTRL_DLY
			; spustit ekn na AUTOREPEAT
	lxi h,RptKad
	mvi m,KBDCTRL_KAD
			; kadence AUTOREPEATu
			; ACC = platn znak - initial press
	ret

KbdOvladacRepeat
	mvi a,0ffh	; dokud nen as, znak se negeneruje
	dcr m		; odpoet doby po initial press
	rnz		; ekm na uplynut initial pause
	inr m		; pak u udruju ta na hodnot 1
	lxi h,RptKad
	dcr m		; rychlost autorepeatu
	rnz		; mezi autorepeat-znaky negeneruji nic
	mvi m,KBDCTRL_KAD
			; reload autorepeat kadence
	lda KbdOvladacPress+1
			; a vrtm platn znak (fce autorepeat)
	ret

; **********************
; Test klvesnice
; vstup: B: kd klvesy
;         00: vlevo
;         01: vpravo
;         02: nahoru
;         02: dol
;         FF: nic
; **********************

KbdOvladaniScan
	mvi b,150
KbdOvladaniScanDelay
	dcr b
	jnz KbdOvladaniScanDelay

	dcr b		; B:=0FFh aka no key

	lxi h,0c04h	; test ipky vlevo
	rst 5
	mvi c,0
	cz KbdOvladacNastav

	lxi h,0e04h	; test ipky vpravo
	rst 5
	mvi c,1
	cz KbdOvladacNastav

	lxi h,0d04h	; test HOME jako nahoru
	rst 5
	mvi c,2
	cz KbdOvladacNastav
	lxi h,0c08h	; test LNLEFT jako nahoru
	rst 5
	mvi c,2
	cz KbdOvladacNastav

	lxi h,0d08h	; test END jako dol
	rst 5
	mvi c,3
	cz KbdOvladacNastav
	lxi h,0e08h	; test LNRIGHT jako dol
	rst 5
	mvi c,3
	cz KbdOvladacNastav

	ret

KbdOvladacNastav
	mov b,c		; zachytm kd stisknut klvesy
	ret

; *********************
; kliknut pi TIMEOUTu
; *********************

Chirp2
	push b
	lxi b,20000
	jmp ChirpCommon

; ***************************
; kliknut pi stisku klvesy
; ***************************

Chirp
	push b
	lxi b,256
ChirpCommon
	push psw
	mvi a,3
	out kbdcwr
ChirpDelay
	dcx b
	mov a,b
	ora c
	jnz ChirpDelay
	mvi a,2
	out kbdcwr
	pop psw
	pop b
	ret
