; ************************************************
; Zapouzden pro voln z odkrvae minovho pole
; ************************************************
 
SafeZmenaCasu
	push b
	push d
	push h
	call ZmenaCasu
	pop h
	pop d
	pop b
	ret

; *************************
; Test zmny asu bhem hry
; *************************

ZmenaCasu
	lda TimeRun
	ana a
	cnz TimeFlow		; fyzick odpoet asu
	rnc			; NEN cifern zmna => konec
				; JE cifern zmna => tisk

; ***************************************************
; Vytiskne as
; Pokud kurzor myi zasahuje do prostoru asomry,
; provede soutisk v buferu a pak kopruje do videoram
; Pedpokld rozsvcen ukazatel myi
; ***************************************************

TiskCasu
	mvi a,10
	call SetCol

	lhld PoziceCasu		; vkov test kolize
	dad h
	dad h
	mov a,h
	adi 12
	lxi h,MysY
	cmp m
	jc TiskCasuOutside
	sui 24
	jc TiskCasuTestX
	cmp m
	jnc TiskCasuOutside
	
TiskCasuTestX
	lhld MysX		; kov test kolize
	xchg
	lda PoziceCasu
	ani 3fh
	mov l,a
	mvi h,0
	dad h
	dad h
	dad h
	adi 3*9
	rst 2
	rst 4
	jc TiskCasuOutside
	lxi b,-(3*9)-12
	dad b
	rst 4
	jnc TiskCasuOutside

TiskCasuInside			; kurzor v kolizi s asomrou
	push b			; zloha videoram do buferu
	lhld AdresaCasu
	xchg
	lxi h,-8000h
	dad d
	xchg
	push d
	push h
	call CopyVideoBlock

	lhld MysAOld		; pesmrovn myi do buferu
	push h
	lxi d,-8000h
	dad d
	shld MysAOld
	lhld MysAdr
	push h
	lxi d,-8000h
	dad d
	shld MysAdr

	rst 6			; tisk asu do buferu
	lhld PoziceCasu
	lxi d,-8000h
	dad d
	shld Prnpos
	lda Time+0
	call prtchr
	lda Time+1
	call prtchr
	lda Time+2
	call prtchr
	call Pixel2AdrBuf
	call MysActBufer

	pop h			; my zpt do videoram
	shld MysAdr
	pop h
	shld MysAOld

	pop d			; penos z buferu do videoram
	pop h
	call CopyVideoBlock
	pop b
	ret

TiskCasuOutside
	push b			; bezpen tisk asomry
	lhld PoziceCasu
	shld Prnpos
	lda Time+0
	call prtchr
	lda Time+1
	call prtchr
	lda Time+2
	call prtchr
	pop b
	ret

; ********
; Tok asu
; ********

TimeFlow
	out uartdat		; restart asovae (UARTu)

	lxi h,Time+3		; peddlika 2x 0,5sec
	dcr m
	stc
	cmc
	rnz
	mvi m,2

	dcx h			; pi asu 999 se
	mov a,m
	dcx h
	add m
	dcx h
	add m
	cpi 3*9
	cnc Chirp2		; ppne
	jnc StopTime		; a zastav asomra

	inx h			; sekundy
	inx h
	inr m
	mov a,m
	cpi 10
	rc			; CY=1 <=> zmna asu
	mvi m,0
	dcx h			; destky sekund
	inr m
	mov a,m
	cpi 10
	rc			; CY=1 <=> zmna asu
	mvi m,0
	dcx h			; stovky sekund
	inr m
	stc			; CY=1 <=> zmna asu
	ret

; *****************
; Zastav celou hru
; *****************

StopGame
	xra a			; pznak GameOver
	sta GameOver

; ********************
; Zastav odpoet asu
; ********************

StopTime
	xra a			; pouze vynulovat
	sta TimeRun		; pznak plynut asu
	ret

; **********************************************
; Kopruje blok mezi fyzickou videoram a buferem
; (HL) >> (DE)
; **********************************************

CopyVideoBlock
	lxi b,0924h		; 9 slice x 36 mikrodk
CopyVideoBlockY
	push b
	push d
	push h
CopyVideoBlockX
	mov a,m
	stax d
	inx h
	inx d
	dcr b
	jnz CopyVideoBlockX
	pop h
	pop d
	mvi c,64
	dad b
	xchg
	dad b
	xchg
	pop b
	dcr c
	jnz CopyVideoBlockY
	ret

; *********************************************************
; Z pixelovch souadnic, kter oee na platn rozsah,
; vypote adresu kurzoru v buferu
; vstup: promnn MysX, MysY
; vstup: HL = adresa kurzoru
; *********************************************************

Pixel2AdrBuf
	call LoadYCoor
	shld MysY
	dad h 
	dad h 
	dad h 
	dad h 
	dad h 
	dad h
	mov a,h
	adi 40h
	mov h,a
	push h

	call LoadXCoor	; HL := HL + pozice bajtu na dku
	shld MysX
	mov a,h
	rar
	mov a,l
	rar
	mov l,a		; nejprve L := X/2 (CY=zbytek)
	mvi h,tbPix2Ofs/256
	mov a,m		; A := pixelov ofset 0..5
	ral
	sta MysBit
	inr h
	mov e,m
	mvi d,0
	pop h
	dad d
	shld MysAdr
	ret
